set echo on
set feedback on
set serveroutput on
var start_date  varchar2(80);
var end_date    varchar2(80);
var sid         varchar2(10);
var host        varchar2(30);
var user        varchar2(30);


spool 3.0.1_Update_Script.log;

SET DEFINE OFF;

begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :start_date from dual;
  select instance_name into :sid from v$instance;
  select host_name into :host from v$instance;
  select user into :user from dual;

  dbms_output.put_line('Script executed on SID:  '||:sid);
  dbms_output.put_line('Script executed on host: '||:host);
  dbms_output.put_line('Script start date/time:  '||:start_date);
  dbms_output.put_line('Script executed by:      '||:user);
end;
/

-- this change cannot be rolled back since the records that are being updated
-- are in an invalid state which must be corrected.
update VAP.PATIENT_CONSENT_DIR pcd
set pcd.EXPIRATION_DATE = PCD.OPTIN_DATE + 365 
where pcd.OPTIN_CONSENT_TYPE_ID = 102
and pcd.OPTOUT_TS is null
and pcd.EXPIRATION_DATE > SYSDATE
and abs(extract(day from pcd.EXPIRATION_DATE - pcd.OPTIN_DATE)) = 3653;

commit;

Set Define on;

Begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :end_date from dual;
  dbms_output.put_line('Script end date/time:    '||:end_date);
  dbms_output.put_line('Script executed in '||(to_date(:end_date, 'mm_dd_yyyy hh24:mi:ss') - to_date(:start_date, 'mm-dd-yyyy hh24:mi:ss')) *24*60*60||' seconds');
end;
/

Spool off;

