CREATE OR REPLACE FUNCTION VAP.GETFRIENDLYSCHEDULEFREQUENCY 
(FREQUENCY VARCHAR2, 
 WEEKLY_RECURRENCE_WEEK NUMBER,
 WEEKLY_RECURRENCE_DAY_OF_WEEK NUMBER, 
 MONTHLY_RECURRENCE_MONTH NUMBER, 
 MONTHLY_RECURRENCE_DAY VARCHAR2
)
  RETURN VARCHAR2 DETERMINISTIC
IS 
V_RETURN VARCHAR2(300);
WEEK_DAY VARCHAR2(10);
MONTH_DAY VARCHAR(30);
BEGIN

  -- convert the WEEKLY_RECURRENCE_DAY_OF_WEEK from a number to the textual day of the week
  WEEK_DAY := 
    CASE  
      WHEN WEEKLY_RECURRENCE_DAY_OF_WEEK = 1 THEN 'Sunday'
      WHEN WEEKLY_RECURRENCE_DAY_OF_WEEK = 2 THEN 'Monday'
      WHEN WEEKLY_RECURRENCE_DAY_OF_WEEK = 3 THEN 'Tuesday'
      WHEN WEEKLY_RECURRENCE_DAY_OF_WEEK = 4 THEN 'Wednesday'
      WHEN WEEKLY_RECURRENCE_DAY_OF_WEEK = 5 THEN 'Thursday'
      WHEN WEEKLY_RECURRENCE_DAY_OF_WEEK = 6 THEN 'Friday'
      ELSE 'Saturday' 
    END;
  
  -- convert the MONTHLY_RECURRENCE_DAY to a readable day of the month
  MONTH_DAY := 
    CASE
      WHEN MONTHLY_RECURRENCE_DAY = 'first' THEN '1st day of the month'
      WHEN MONTHLY_RECURRENCE_DAY = 'fifteenth' THEN '15th of the month'
      ELSE 'last day of the month'
    END;

  IF FREQUENCY = 'DAILY' THEN
        V_RETURN := 'Daily';
    END IF;

    IF FREQUENCY = 'WEEKLY' THEN
        V_RETURN := 'Weekly recurring every ' || TO_CHAR(WEEKLY_RECURRENCE_WEEK) || ' week(s) on ' || WEEK_DAY;
    END IF;

    IF FREQUENCY = 'MONTHLY' THEN 
        V_RETURN := 'Monthly recurring every ' || TO_CHAR(MONTHLY_RECURRENCE_MONTH) || ' month(s) on the ' || MONTH_DAY;
    END IF;

    RETURN V_RETURN;

  END;
/