CREATE TABLE VAP.ALLOWED_ORG
(
  ORG_ID                      NUMBER            NOT NULL,
  ORG_NUMBER                  VARCHAR2(255 BYTE) NOT NULL,
  ORG_OID                     VARCHAR2(255 BYTE) NOT NULL,
  ORG_NAME                    VARCHAR2(255 BYTE) NOT NULL,
  ORG_DOMAIN                  VARCHAR2(255 BYTE) NOT NULL,
  ORG_COMMUNITY_ID_PREFIX     VARCHAR2(255 BYTE) NOT NULL,
  ORG_CONTACT                 VARCHAR2(255 BYTE),
  ORG_PHONE_NUMBER            VARCHAR2(255 BYTE),
  ACTIVE                      CHAR(1 BYTE)      NOT NULL,
  ORG_CONSUMER_ONLY           CHAR(1 CHAR)      NOT NULL,
  IS_TRUSTED_CLINICAL_SOURCE  CHAR(1 BYTE)      DEFAULT 'N'                   NOT NULL,
  ORG_DESCRIPTION             VARCHAR2(255 BYTE)
);


CREATE UNIQUE INDEX VAP.ALLOWED_ORG_IDX ON VAP.ALLOWED_ORG
(ORG_NUMBER, ORG_OID);

CREATE UNIQUE INDEX VAP.ALLOWED_ORG_PK ON VAP.ALLOWED_ORG
(ORG_ID);

ALTER TABLE VAP.ALLOWED_ORG ADD (
  CONSTRAINT ALLOWED_ORG_PK
  PRIMARY KEY
  (ORG_ID)
  USING INDEX VAP.ALLOWED_ORG_PK
  ENABLE VALIDATE);
