CREATE TABLE VAP.DESCRIPTOR
(
  DESCRIPTOR_ID  NUMBER(19)                     NOT NULL,
  NAME           VARCHAR2(500 CHAR),
  TEXT           CLOB
);


CREATE UNIQUE INDEX VAP.DESCRIPTOR_PK ON VAP.DESCRIPTOR
(DESCRIPTOR_ID);

CREATE UNIQUE INDEX VAP.UX_DESCRIPTOR_NAME ON VAP.DESCRIPTOR
(NAME);

ALTER TABLE VAP.DESCRIPTOR ADD (
  CONSTRAINT DESCRIPTOR_PK
  PRIMARY KEY
  (DESCRIPTOR_ID)
  USING INDEX VAP.DESCRIPTOR_PK
  ENABLE VALIDATE);

ALTER TABLE VAP.DESCRIPTOR ADD (
  CONSTRAINT UX_DESCRIPTOR_NAME
  UNIQUE (NAME)
  USING INDEX VAP.UX_DESCRIPTOR_NAME
  ENABLE VALIDATE);
