/* updated with 2.7.0 release update */
CREATE OR REPLACE FORCE VIEW VAP.DELAYED_CONSENT_VIEW
(
  DELAYED_CONSENT_ID, PATIENT_IEN, PATIENT_SSN, PATIENT_LAST_NAME, PATIENT_FIRST_NAME, PATIENT_MIDDLE_NAME, DATE_ADDED, USER_ID, CONSENT_TYPE_ID,
  PARENT_STATION_NUMBER, STATION_NUMBER, FACILITY_NAME, STATUS, RESOLUTION_DATE, IS_TEST_PATIENT, PARENT_FACILITY_NAME, VISN_NUMBER
) AS
  select DELAYED_CONSENT_ID, PATIENT_IEN, PATIENT_SSN, PATIENT_LAST_NAME, PATIENT_FIRST_NAME, PATIENT_MIDDLE_NAME, DATE_ADDED, USER_ID,
       CONSENT_TYPE_ID, case when fa.FACILITY_PARENT is null then fa.FACILITY_STATION else fa.FACILITY_PARENT end as PARENT_STATION_NUMBER,
       STATION_NUMBER, fa.FACILITY_NAME, STATUS, RESOLUTION_DATE, ISTESTPATIENT(PATIENT_SSN), fb.FACILITY_NAME as PARENT_FACILITY_NAME, VISN_NUMBER
from DELAYED_CONSENT d
left outer join FACILITY fa on d.STATION_NUMBER = fa.FACILITY_STATION
left outer join FACILITY fb on case when fa.FACILITY_PARENT is null then fa.FACILITY_STATION else fa.FACILITY_PARENT end = fb.FACILITY_STATION
left outer join VISN v on fa.VISN_ID = v.ID;
