package gov.va.nvap.server.service.permission.sls.simulator;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import gov.va.nvap.common.util.DocumentBuilderFactoryUtil;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Class to Parse the XML Document
 * @author Sricharan Reddy *
 */
public class XmlParseUtil
{

	public static final String PATIENT_ID_XPATH = "/ClinicalDocument/recordTarget/patientRole/id/@extension";
	
	/**
	 * Function to parse the XML Document
	 * @param   xmlArray the Byte array representing the XML Document
	 * @return  The string object representing the Patient ID from the Document 
	 */
	public static String parse(byte[] xmlArray) throws XmlParseException
	{
            String id = null;
            try 
            {
		final DocumentBuilderFactory factory = DocumentBuilderFactoryUtil.getDocumentBuilderFactory(null, false, false, false);
		DocumentBuilder db;
            
                db = factory.newDocumentBuilder();
           
		ByteArrayInputStream byteStream = new ByteArrayInputStream(xmlArray);
                InputSource is = new InputSource(byteStream);
		Document doc;
            
                doc = db.parse(is);
           
		doc.getDocumentElement().normalize();
		XPathFactory xpf = XPathFactory.newInstance();
                XPath xpath = xpf.newXPath();
            
                id = (String) xpath.evaluate(PATIENT_ID_XPATH, doc, XPathConstants.STRING);
                //}
//	     catch (XPathExpressionException | ParserConfigurationException | IOException |SAXException e)
//		 {
//			throw new RuntimeException(e);
//		 }
                } catch (ParserConfigurationException ex) {
                    throw new XmlParseException(ex);
                } catch (SAXException ex) {
                    throw new XmlParseException(ex);
                } catch (IOException ex) {
                    throw new XmlParseException(ex);
                } catch (XPathExpressionException ex) {
                    throw new XmlParseException(ex);
                }
	  
		return id!=null?id:"";
	 }
	
}
