/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.dao;

import gov.va.nvap.web.user.document.UserDocumentScheduleAudit;
import java.util.HashMap;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Johann P. Sonnenberg
 */
public class UserDocumentScheduleAuditDAO {
    
    @PersistenceContext
    private EntityManager em;

    /**
     * Set the entity manager (Injected by Spring).
     * @param em
     */
    public void setEntityManager(final EntityManager em) {
        this.em = em;
    }
    
    @Transactional
    public HashMap<String, Object> getUserDocumentScheduledAudits(Long scheduleId) {
        Query q = this.em.createQuery("SELECT u FROM UserDocumentScheduleAudit u WHERE u.scheduleId = :scheduleId ORDER BY u.runStartDate DESC");
        
        q.setParameter("scheduleId", scheduleId);
        
        Query cq = em.createQuery("SELECT COUNT(udsa.auditId) FROM UserDocumentScheduleAudit udsa WHERE udsa.scheduleId = :scheduleId");

        cq.setParameter("scheduleId", scheduleId);
        
        HashMap<String, Object> hm = new HashMap<String, Object>();
        hm.put("results", (List<UserDocumentScheduleAudit>) q.getResultList());
        hm.put("count", (Long) cq.getSingleResult());
        
        return hm;
    }
    
    @Transactional
    public UserDocumentScheduleAudit create(UserDocumentScheduleAudit userDocumentScheduleAudit) throws Exception {
        try {
            this.em.persist(userDocumentScheduleAudit);
        } catch (final Exception ex) {
            throw ex;
        }
        
        return userDocumentScheduleAudit;
    }
    
    @Transactional
    public UserDocumentScheduleAudit update(UserDocumentScheduleAudit userDocumentScheduleAudit) throws Exception {
        try {
            this.em.merge(userDocumentScheduleAudit);
        } catch (final Exception ex) {
            throw ex;
        }
        
        return userDocumentScheduleAudit;
    }
    
    @Transactional
    public boolean isScheduledTaskCurrentlyRunning() {
        boolean isRunning = false;
        Query q = this.em.createQuery("SELECT COUNT(udsa.auditId) FROM UserDocumentScheduleAudit udsa WHERE udsa.status = 'PROCESSING'");
        
        if((Long) q.getSingleResult() > 0) {
            isRunning = true;
        }
        
        return isRunning;
    }
}
