package gov.va.nvap.web.facility;

import java.math.BigDecimal;

/**
 *
 * @author Raul Alfaro
 */
public class FacilityInfo {

    private final BigDecimal id;
    private final Boolean allowed;
    private final String dns;
    private final String facilityName;
    private final String facilityStation;
    private final BigDecimal visnId;
    private final String phone;
    private final String address;
    private final String city;
    private final String state;
    private final String postalCode;
    private final String parentStationNumber;
    private final String active;
    private final String visnName;
    private final String children;
    private final String parentName;

    public FacilityInfo(BigDecimal id, String facilityStation, String dns, String facilityName, BigDecimal allowed, BigDecimal visnId, String phone, String address, String city, String state, String postalCode, String parentStationNumber, String active, String visnName, String children, String parentName) {
        this.id = id;
        this.facilityStation = facilityStation;
        this.dns = dns;
        this.facilityName = facilityName;
        this.allowed = (allowed.equals(new BigDecimal("1")));
        this.visnId = visnId;
        this.phone = phone;
        this.address = address;
        this.city = city;
        this.state = state;
        this.postalCode = postalCode;
        this.parentStationNumber = parentStationNumber;
        this.active = active;
        this.visnName = visnName;
        this.children = children;
        this.parentName = parentName;
    }

    public BigDecimal getId() {
        return id;
    }

    public String getDns() {
        return dns;
    }

    public Boolean isAllowed() {
        return allowed;
    }

    public String getFacilityName() {
        return facilityName;
    }

    public String getFacilityStation() {
        return facilityStation;
    }

    public BigDecimal getVisnId() {
        return visnId;
    }

    public String getPhone() {
        return phone;
    }

    public String getAddress() {
        return address;
    }

    public String getCity() {
        return city;
    }

    public String getState() {
        return state;
    }

    public String getPostalCode() {
        return postalCode;
    }

    public String getParentStationNumber() {
        return parentStationNumber;
    }

    public String getActive() {
        return active;
    }

    public String getVisnName() {
        return visnName;
    }

    public String getChildren() {
        return children;
    }

    public String getParentName() {
        return parentName;
    }

}
