<%-- 
    Document   : dayOfWeekPicker
    Created on : Feb 9, 2018, 8:37:40 AM
    Author     : Johann P. Sonnenberg
--%>

<%@tag description="creates a dropdown of days of the week" pageEncoding="UTF-8"%>

<%@attribute name="prefixId" required="true" description="prefix to use for all the field ids. i.e. using bro will produce a field with an id of broDayOfWeek" %>
<%@attribute name="prefixName" required="true" description="prefix to use for all the field names. i.e. using bro will produce a field with a name of broDayOfWeek." %>
<%@attribute name="labelPrefix" required="true" description="text to put before the aria-label i.e. using Start will produce an aria-label for the field as Start Day of Week." %>
<%@attribute name="useNumericDayOfWeekValue" required="true" type="Boolean" description="boolean if the value of the option for the day of the week should be numeric. i.e. 1 = Sunday. if not, then value and option should would both be Sunday." %>
<%@attribute name="selected" required="false" description="the value of the option in the list to be selected" %>
<%@attribute name="cssClass" required="false" description="css class name to be applied to this field" %>
<%@attribute name="descriptor" required="false" description="the text to use for the help (descriptor) text" %>
<%@attribute name="tooltipPrefix" required="false" description="the prefix of the aria jquery tooltip to use for this dropdown. i.e. insideform" %>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%-- tag content goes here --%>
<select id="${prefixId}DayOfWeek" name="${prefixName}DayOfWeek" class="form-control js-simple-tooltip ${cssClass}" aria-label="${labelPrefix} Day of Week" data-simpletooltip-text="<c:out value="${descriptor}" />" data-simpletooltip-prefix-class="<c:out value="${tooltipPrefix}" />" >
    <c:choose>
        <c:when test="${useNumericDayOfWeekValue}">
            <option value="1" <c:out value="${!empty selected && selected == '1' ? 'selected=selected' : ''}" /> >Sunday</option>
            <option value="2" <c:out value="${!empty selected && selected == '2' ? 'selected=selected' : ''}" /> >Monday</option>
            <option value="3" <c:out value="${!empty selected && selected == '3' ? 'selected=selected' : ''}" /> >Tuesday</option>
            <option value="4" <c:out value="${!empty selected && selected == '4' ? 'selected=selected' : ''}" /> >Wednesday</option>
            <option value="5" <c:out value="${!empty selected && selected == '5' ? 'selected=selected' : ''}" /> >Thursday</option>
            <option value="6" <c:out value="${!empty selected && selected == '6' ? 'selected=selected' : ''}" /> >Friday</option>
            <option value="7" <c:out value="${!empty selected && selected == '7' ? 'selected=selected' : ''}" /> >Saturday</option>
        </c:when>
        <c:otherwise>
            <option value="Sunday" <c:out value="${!empty selected && selected == 'Sunday' ? 'selected=selected' : ''}" /> >Sunday</option>
            <option value="Monday" <c:out value="${!empty selected && selected == 'Monday' ? 'selected=selected' : ''}" /> >Monday</option>
            <option value="Tuesday" <c:out value="${!empty selected && selected == 'Tuesday' ? 'selected=selected' : ''}" /> >Tuesday</option>
            <option value="Wednesday" <c:out value="${!empty selected && selected == 'Wednesday' ? 'selected=selected' : ''}" /> >Wednesday</option>
            <option value="Thursday" <c:out value="${!empty selected && selected == 'Thursday' ? 'selected=selected' : ''}" /> >Thursday</option>
            <option value="Friday" <c:out value="${!empty selected && selected == 'Friday' ? 'selected=selected' : ''}" /> >Friday</option>
            <option value="Saturday" <c:out value="${!empty selected && selected == 'Saturday' ? 'selected=selected' : ''}" /> >Saturday</option>
        </c:otherwise>
    </c:choose>
</select>