<%@tag description="Simple Wrapper Tag" pageEncoding="UTF-8"%>
<%@attribute name="headerText" required="false"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
        <title>Veterans Authorizations and Preferences</title>

        <!-- Bootstrap -->
        <link rel="stylesheet" type="text/css" href="resources/bootstrap/css/vap-bootstrap-theme.min.css?<c:out value="${systemVersion}" />">

        <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
        <script src="resources/js/jquery/jquery-2.2.0.min.js?<c:out value="${systemVersion}" />"></script>
        <!-- Include all compiled plugins (below), or include individual files as needed -->
        

        <link href="resources/css/vap.css?<c:out value="${systemVersion}" />" rel="stylesheet">

        <script src="resources/js/validator.js?<c:out value="${systemVersion}" />"></script>

        <script src="resources/js/moment.js?<c:out value="${systemVersion}" />"></script>

        <script src="resources/js/numeral.min.js?<c:out value="${systemVersion}" />"></script>

        <script src="resources/js/vap/common.js?<c:out value="${systemVersion}" />"></script>
        
        <script src="resources/js/ChartJS2.3/Chart.js?<c:out value="${systemVersion}" />"></script>
        
        <script src="resources/js/jquery.blockUI.min.js?<c:out value="${systemVersion}" />"></script>
        
        <link rel="stylesheet" type="text/css" href="resources/js/jquery-ui/jquery-ui.min.css?<c:out value="${systemVersion}" />"/>
        <script type="text/javascript" src="resources/js/jquery-ui/jquery-ui.min.js?<c:out value="${systemVersion}" />"></script>

        <script src="resources/bootstrap/js/bootstrap.min.js?<c:out value="${systemVersion}" />"></script>
        
        <!-- qTip -->
        <link type="text/css" rel="stylesheet" href="resources/js/qTip/jquery.qtip.min.css?<c:out value="${systemVersion}" />" /> 
        <script type="text/javascript" src="resources/js/qTip/jquery.qtip.min.js?<c:out value="${systemVersion}" />"></script> 
        
        <!-- ariaTooltip -->
        <link type="text/css" rel="stylesheet" href="resources/js/ariaTooltip/js-simple-tooltip.css?<c:out value="${systemVersion}" />" />
        <script type="text/javascript" src="resources/js/ariaTooltip/jquery-accessible-simple-tooltip-aria.js?<c:out value="${systemVersion}" />"></script>
        
        <!-- font awesome -->
        <link href="resources/font-awesome/css/font-awesome.min.css?<c:out value="${systemVersion}" />" rel="stylesheet">

        <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
        <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
        <!--[if lt IE 9]>
        <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
        <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
        <![endif]-->

        <!-- data tables -->
        <%-- <link rel="stylesheet" type="text/css" href="resources/js/DataTables/datatables.min.css?<c:out value="${systemVersion}" />"/> --%>
        <link rel="stylesheet" type="text/css" href="resources/js/DataTables/DataTables-1.10.11/css/dataTables.bootstrap.min.css?<c:out value="${systemVersion}" />"/>

        <script type="text/javascript" src="resources/js/DataTables/datatables.min.js?<c:out value="${systemVersion}" />"></script>
        <script type="text/javascript" src="resources/js/DataTables/DataTables-1.10.11/js/dataTables.bootstrap.min.js?<c:out value="${systemVersion}" />"></script>
        <script type="text/javascript" src="resources/js/DataTables/plugins/sum().js?<c:out value="${systemVersion}" />"></script>
        
        <%-- clipboard --%>
        <script type="text/javascript" src="resources/js/clipboard.min.js"></script>
        
        <%-- fav icon --%>
        <link rel="shortcut icon" href="resources/images/favicon.ico" type="image/x-icon" />
        
        <%-- ab-datepicker --%>
        <link rel="stylesheet" type="text/css" href="resources/js/ab-datepicker/css/datepicker.css?<c:out value="${systemVersion}" />"/>
        <link rel="stylesheet" type="text/css" href="resources/js/ab-datepicker/css/vap.datepicker.css?<c:out value="${systemVersion}" />"/> <%-- vap specific theme for the datepicker. also has overrides in it for base classes --%> 
        <script type="text/javascript" src="resources/js/ab-datepicker/js/datepicker.vap.min.js?<c:out value="${systemVersion}" />"></script>
        
        <%-- toast --%>
        <link type="text/css" rel="stylesheet" href="resources/js/jquery-toast/jquery.toast.min.css?<c:out value="${systemVersion}" />" />
        <script type="text/javascript" src="resources/js/jquery-toast/jquery.toast.min.js?<c:out value="${systemVersion}" />"></script>
        
        <script language="JavaScript">
            $(document).ready(function() {
                VAP.common.initVAP();
                
                //global variables to be used throughout VAP
                VAP.common.scheduledExportThreshold = <c:out value="${scheduledExportMin}" />;

                VAP.common.reportTable;
                VAP.common.reportNoRecordsMessage = ''; //used to change the no records method for a data table. set this in the ajax or initComplete for a DataTable

                VAP.common.validateSSNsBeforeExport = false; //setting this to false as most exports do not require this. this variable is set on the pages that need it changed to true
                
                //global variables for use in the Advanced Scheduling modal (and elsewhere if needed). these DO need to be set when used as these defaults are not terrible valid/useful.
                VAP.common.advancedScheduledTaskCap = 0;
                VAP.common.advancedScheduledTaskUserCurrentTaskCount = 0;
                VAP.common.advancedScheduledTaskUserCanAddMore = true;
            });
        </script>
    </head>
    <body>
        <a href="#content" class="sr-only sr-only-focusable">Skip navigation</a>
  	<div class="vapHeader">
            <a href="http://vaww.va.gov/"><img src="resources/images/header_logo_final.png" border="0" class="pad-left-5" alt="United States Department of Veterans Affairs logo" /></a>
  	</div>
        
        <jsp:include page="/WEB-INF/web/topMenu.jsp"/>
        
        <div id="content" class="container-fluid" tabindex="-1">
            <c:choose>
                <c:when test="${not empty headerText}">
                    <div class="row">
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                            <h3><c:out value="${headerText}" /></h3>
                            <hr />
                        </div>
                    </div>
                </c:when>
                <c:otherwise>
                    <div class="pad-top-20"></div><%-- give the content some padding between it and the top nav if no header is specified --%>
                </c:otherwise>
            </c:choose>
            <jsp:doBody/>
        </div><!-- /.container -->

        <footer class="footer navbar-fixed-bottom">
            <div class="container">
                <p class="text-center pad-top-15">
                    <a href="http://vaww.va.gov/accessible/" title="Section 508 Accessibility" target="_blank" class="pad-right-10">Section 508 Accessibility</a>
                    <a href="http://vaww.va.gov/privacy/" title="Privacy policy for the VA Intranet" target="_blank" class="pad-right-10">Intranet Privacy Policy</a>
                    <a href="http://vaww.va.gov/ohrm/EmployeeRelations/grievance.htm" title="No Fear Act information" target="_blank" class="pad-right-10">No Fear Act</a>
                    <a href="http://vista.med.va.gov/termsofuse.htm" title="Terms of Use" target="_blank" class="pad-right-10">Terms of Use</a>
                    <a href="http://vaww.va.gov/med/" title="Intranet site for Veterans Administration" target="_blank" class="pad-right-10">VHA Intranet Home</a>
                    <a href="http://vbaw.vba.va.gov/" title="Intranet site for Veterans Benefits Administration" target="_blank" class="pad-right-10">VBA Intranet Home</a>
                    <a href="http://vaww.cem.va.gov/" title="Intranet site for National Cemetery Administration" target="_blank" class="pad-right-10">NCA Intranet Home</a>
                    <a href="http://vista.med.va.gov/disclaimer.htm" title="Web Disclaimer" target="_blank">Disclaimer</a>
                </p>
                <%-- uncomment once we get approval to have the version on the bottom right <p class="pull-right footer-version">Version <c:out value="${systemVersion}" /></p> --%>
            </div>
        </footer>

        <!-- global modals -->
        <div class="modal fade" id="confirmLogoutModal" role="dialog" data-backdrop="static" aria-labelledby="confirmLogoutModalLabel">
            <div class="vertical-alignment-helper">
                <div class="modal-dialog vertical-align-center" role="document">
                    <div class="modal-content" tabindex="-1" id="confirmLogoutModalLabel" aria-live="assertive" role="alert">
                        <div class="modal-header">
                            <h4 class="modal-title">Confirm Logout</h4>
                        </div>
                        <div class="modal-body">
                            <p>
                                Are you sure you want to log out?
                            </p>
                            <p>
                                After you logout, please close all browser windows to ensure cached information is removed.
                            </p>
                        </div>
                        <div class="modal-footer">
                            <button type="button" id="confirmLogoutModalcancelLogout" class="btn btn-default" data-dismiss="modal">Cancel</button>
                            <button type="button" id="confirmLogoutModalLogout" class="btn btn-primary">Logout</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal fade" id="confirmExportModal" data-backdrop="static" aria-labelledby="confirmExportModalLabel">
            <div class="vertical-alignment-helper">
                <div class="modal-dialog vertical-align-center" role="document">
                    <div class="modal-content" tabindex="-1" id="confirmExportModalLabel" aria-live="assertive" role="alert">
                        <div class="modal-header">
                            <h4 class="modal-title">Export Notice</h4>
                        </div>
                        <div class="modal-body"></div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                            <button type="button" id="confirmExportModalExport" class="btn btn-primary" data-dismiss="modal">Export</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </body>
</html>
