<%-- 
    Document   : log of a single managed scheduled export. 
    Created on : March 9, 2018, 11:07:29 AM
    Author     : Johann P. Sonnenberg
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<f:mainTemplate headerText="Advanced Scheduling Log">
    <script language="JavaScript">
        $(document).ready(function(){
            VAP.common.reportTable = $('#reportTable').DataTable( {
                destroy: true,
                searching: false,
                processing: true,
                serverSide: false,
                order: [[2, 'desc']],
                columnDefs: [
                    {className: "vertical-align-center", targets: 0}
                ],
                lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                pageLength: 25
            });
            
            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
            
            //need to call this when the table is initially drawn
            VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
            
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
            });
        });
    </script>
    <h4><c:out value="${userDocumentSchedule.userDefinedReportName}" /></h4>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-body">
                <div class="pull-right">
                    <a href="ManageScheduledExports.do_sec?show=true" class="btn btn-default" title="Back">Back</a>
                </div>
                <table id="reportTable" class="display table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['advancedSchedulingLogStatusColumn']}" />"><span data-simpletooltip-target="tableheader">Status</span></th>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['advancedSchedulingLogFormatColumn']}" />"><span data-simpletooltip-target="tableheader">Format</span></th>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['advancedSchedulingLogRunStartDateColumn']}" />"><span data-simpletooltip-target="tableheader">Run Start Date (CT)</span></th>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['advancedSchedulingLogRunEndDateColumn']}" />"><span data-simpletooltip-target="tableheader">Run End Date (CT)</span></th>
                        </tr>
                    </thead>
                    <tbody>
                        <c:forEach var="log" items="${logs}" varStatus="i">
                            <tr role="row">
                                <td role="gridcell"><c:out value="${log.status}" /></td>
                                <td role="gridcell"><c:out value="${log.format}" /></td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${!empty log.runStartDate}">
                                            <fmt:formatDate pattern="MM/dd/yyyy" value="${log.runStartDate}" />
                                            <br />
                                            <fmt:formatDate pattern="hh:mm:ss a" value="${log.runStartDate}" />
                                        </c:when>
                                        <c:otherwise>
                                            
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${!empty log.runEndDate}">
                                            <fmt:formatDate pattern="MM/dd/yyyy" value="${log.runEndDate}" />
                                            <br />
                                            <fmt:formatDate pattern="hh:mm:ss a" value="${log.runEndDate}" />
                                        </c:when>
                                        <c:otherwise>
                                            
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                            </tr>
                        </c:forEach>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</f:mainTemplate>