<%--
    Document   : Consent Directive Batch Announce
    Created By : Stephen Schrank
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);

    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Batch Announce Patients ${flow eq 'result' ? '- Query Results' : '- Criteria'}">
    <script type="text/javascript" src="resources/js/OptionTransfer.js"></script>
    <script language="JavaScript">
        var opt = new OptionTransfer("list1","list2");
        opt.setAutoSort(true);
        opt.setDelimiter(",");
        opt.saveNewLeftOptions("newLeft");
        opt.saveNewRightOptions("remoteOrganization");
    </script>
    <c:choose>
        <c:when test="${flow == 'result'}">
            <script type="text/javascript">
                var bReady = false;			
                window.onbeforeunload = confirmExit;			
                function confirmExit(){
                    if (!bReady){
                        alert("Please press \"Continue\" or \"Cancel\" to exit this page.");
                        if(navigator.appName.indexOf('Microsoft Internet Explorer') != -1) {         
                            window.setTimeout(function(){
                                document.execCommand('Stop');
                            }, 1);
                        } else {
                            window.setTimeout(function(){
                                window.stop();
                            }, 1);        		
                        }
                    }
                }
                
                function makeReady(){
                    bReady = true;
                }
            </script>
        </c:when>
    </c:choose>
    <script> 
        $(document).ready(function() {
            <c:choose>
                <c:when test="${flow != 'result'}">
                    opt.init(document.batchAnnounceForm);
                    //setFocus(batchAnnounceForm.list1);
                </c:when>
                <c:otherwise>
                    //initial data table setup and call for the first recordset
                    $.fn.dataTable.ext.errMode = 'none';

                    VAP.common.reportTable = $('#tblReport').DataTable({
                        searching: false,
                        processing: true,
                        serverSide: false,
                        paging: false,
                        info: false,
                        columnDefs: [
                            {className: "text-right", targets: [1]},
                            {orderable: false, targets: [0,1]}
                        ],
                        "footerCallback": function ( row, data, start, end, display ) {
                            var api = this.api(), data;

                            // Update footer
                            $(api.column(1).footer() ).html(
                                api.column(1, {page:'current'}).data().sum()
                            );
                        }, 
                        language: {
                            emptyTable: "No records found"
                        },
                        dom: 'tp'
                    });

                    VAP.common.setProcessingForDataTable('tblReport');

                    VAP.common.reportTable.on('draw', function () {
                        VAP.common.addAriaToDataTable('tblReport', VAP.common.reportTable);
                    });
                </c:otherwise>
            </c:choose>
        });        
    </script>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <cpp:errors /> 
        </div>
    </div>
    <c:choose>
        <c:when test="${flow == 'result'}">
            <c:choose>
                <c:when test="${outcome} == 'success'">
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                            <div class="alert alert-success alert-dismissible" role="alert">
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                Batch Announce message has been enqueued.
                            </div>
                        </div>
                    </div>
                </c:when>
                <c:when test="${outcome} == 'failed'">
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                            <div class="alert alert-danger alert-dismissible" role="alert">
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                Batch Announce message enqueue failed.
                            </div>
                        </div>
                    </div>
                </c:when>
            </c:choose>
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                    <form name="batchAnnounceForm" id="batchAnnounceForm" action="BatchAnnounce.do_sec" method="POST" onsubmit="makeReady();">
                        <table width="100%" class="table table-striped" id="tblReport">
                            <thead>
                                <tr role="row">                                 
                                    <th class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsOrganzationNameColumn']}"/>" role="columnheader"><span data-simpletooltip-target="tableheader">Organization Name</span></th>
                                    <th class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsPatientCountColumn']}"/>" role="columnheader"><span data-simpletooltip-target="tableheader">Patient Count</span></th>
                                </tr>
                            </thead>
                            <tbody>
                                <c:choose>
                                    <c:when test="${empty errorMessage}">
                                        <c:forEach var="r" items="${batchSummary}">
                                            <tr role="row">
                                                <td role="gridcell"><c:out value="${r.targetOrganizationName}" /></td>
                                                <td class="text-right" role="gridcell"><c:out value="${r.batchSize}" /></td>
                                            </tr>
                                        </c:forEach>
                                    </c:when>
                                </c:choose>
                            </tbody>
                            <tfoot>
                                <tr role="row">
                                    <td role="gridcell" class="bold text-left">Total:</td>
                                    <td role="gridcell" class="bold text-right"></td>
                                </tr>
                            </tfoot>
                        </table>
                        <div class="text-right">
                            <input name="cancel" title="Cancel" class="btn btn-default" type="submit" value="Cancel" />
                            <c:choose>
                                <c:when test="${!empty batchSummary}">
                                    <input name="accept" title="Continue" class="btn btn-primary margin-left-5" type="submit" value="Continue" />
                                </c:when>
                                <c:otherwise>
                                    <input name="accept" title="Continue" disabled="disabled" class="btn btn-primary margin-left-5" type="submit" value="Continue" />
                                </c:otherwise>
                            </c:choose>
                        </div>
                    </form>
                </div>                               
            </div>
        </c:when>
        <c:otherwise>
            <script language="JavaScript">
                $(document).ready(function () {
                    /*$("#startDate").datepicker({
                        maxDate: 0,
                        dateFormat: 'mm/dd/yy',
                        onClose: function (selectedDate) {
                            $("#endDate").datepicker("option", "minDate", selectedDate);
                            $(this).focus();
                        }
                    });

                    $("#endDate").datepicker({
                        maxDate: 0,
                        dateFormat: 'mm/dd/yy',
                        onClose: function (selectedDate) {
                            $("#startDate").datepicker("option", "maxDate", selectedDate);
                            $(this).focus();
                        }
                    });*/
        
                    $('#startDate').datepicker({
                        theme: 'vap',
                        inputFormat: 'MM/dd/yyyy',
                        outputFormat: 'MM/dd/yyyy',
                        gainFocusOnConstruction: false,
                        max: '<c:out value="${maxDate}" />',
                        onUpdate: function(curValue) {
                            $('#endDate').datepicker('min', curValue);
                        }
                    });

                    $('#endDate').datepicker({
                        theme: 'vap',
                        inputFormat: 'MM/dd/yyyy',
                        outputFormat: 'MM/dd/yyyy',
                        gainFocusOnConstruction: false,
                        max: '<c:out value="${maxDate}" />',
                        onUpdate: function(curValue) {
                            $('#startDate').datepicker('max', curValue);
                        }
                    });
                    
                    $('#startDate,#endDate,#fileName').on('change', function () {
                        //if either date changes or ssn, hide the error message if its not already hidden
                        $('#errorMessage').hide();
                    });
                    $('.moveButtons').on('click', function () {
                        //if any one of the "move" buttons are clicked, that means a change has happened in the multi select boxes so hid the error message 
                        $('#errorMessage').hide();
                        validateList2();
                    });
                    
                    // We can attach the `fileselect` event to all file inputs on the page
                    $(document).on('change', ':file', function() {
                        var input = $(this),
                        numFiles = input.get(0).files ? input.get(0).files.length : 1,
                        label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
                        input.trigger('fileselect', [numFiles, label]);
                    });

                    // We can watch for our custom `fileselect` event like this

                    $(':file').on('fileselect', function(event, numFiles, label) {
                        var input = $(this).parents('.input-group').find(':text'),
                        log = numFiles > 1 ? numFiles + ' files selected' : label;

                        if( input.length ) {
                            input.val(log);
                        } else {
                            if( log ) alert(log);
                        }
                    });
                    
                    //initially block the file upload
                    $('#divFileUpload').block({
                        message: null,
                        overlayCSS : { cursor: 'not-allowed'}
                    });
                    
                    $('#list2').on('focusout', function() {
                        validateList2();
                    });
                    
                    $('#fileUploadButton').on('click', function(event){
                        $(':file').click(); //pop the file upload dialog
                    });
                });
                
                validateList2 = function() {
                    if ($('#list2')[0].children.length === 0) {
                        //we don't have anything selected, so we better show this is required
                        $('#divList2Label').addClass('has-error has-danger');
                        $('#divList2').addClass('has-error has-danger');
                    } else {
                        $('#divList2Label').removeClass('has-error has-danger');
                        $('#divList2').removeClass('has-error has-danger');
                    }
                }
                
                function clearSelectedFile() {
                    $('#fileName').val('');
                    $('#fileNameHolder').val('');
                    $("#btnClear").hide();    
                }

                function isFormValid() {
                    if ($('#list2')[0].children.length === 0) {
                        $('#errorMessage').html("Please select at least one organization.");
                        $('#errorMessage').show();
                        
                        return false;
                    }
                    if ($("#bat1").is(':checked')) {
                        //validate dates
                        var startDate = $('#startDate').val();
                        var endDate = $('#endDate').val();

                        var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);

                        if (errorMessage != '')
                        {
                            //we have an error so show the error, and then don't send the ajax request
                            $('#errorMessage').html(errorMessage);
                            $('#errorMessage').show();

                            return false;
                        } else {
                            return true;
                        }
                    } else {
                        // Batch announcing using an uploaded file
                        if ($("#fileName").value === "") {
                            $('#errorMessage').html("Please select a file to upload.");
                            $('#errorMessage').show();
                            
                            return false;
                        }
                    }
                    return true;
                }

                function onBatchAnnounceTypeChange(rb) {
                    document.getElementById("startDate").disabled = rb.value === "2";
                    document.getElementById("endDate").disabled = rb.value === "2";
                    document.getElementById("reannounce").disabled = rb.value === "2";
                    
                    if(rb.value === "1"){
                        //block the file upload
                        $('#divFileUpload').block({
                            message: null,
                            overlayCSS : { cursor: 'not-allowed'}
                        });
                        $('#fileUploadButton').prop('disabled', true);
                    } else {
                        //unblock the file upload
                        $('#divFileUpload').unblock();
                        $('#fileUploadButton').prop('disabled', false);
                    }
                }

                function validateFileExt(fileName) {
                    var validExts = new Array(".xlsx", ".xls", ".csv");
                    var fileExt = fileName.substring(fileName.lastIndexOf('.')).toLowerCase();
                    if (validExts.indexOf(fileExt) < 0) {
                        $('#errorMessage').html("You selected an invalid file. Please select an Excel or CSV file");
                        $('#errorMessage').show();
                        
                        clearSelectedFile();
                    } else {
                        $("#btnClear").show();
                    }
                }
            </script>
            
            <c:choose>
                <c:when test="${outcome} == 'success'">
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                            <div class="alert alert-success alert-dismissible" role="alert">
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                Batch Announce message has been enqueued.
                            </div>
                        </div>
                    </div>
                </c:when>
                <c:when test="${outcome} == 'failed'">
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                            <div class="alert alert-danger alert-dismissible" role="alert">
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                Batch Announce message enqueue failed.
                            </div>
                        </div>
                    </div>
                </c:when>
            </c:choose>
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                    <div class="alert alert-info">
                        <p>Select one or more organizations to send the announcements to.</p>
                        <p>
                            The <i>Start Date</i> and <i>End Date</i> are based on the date that the patient opted in or out.
                            If only <i>Start Date</i> is entered, patients opting in or out on or after the date entered will be announced.
                            If only <i>End Date</i> is entered, patients opting in or out prior to and including the date entered will be announced.
                            If <i>Start Date</i> and <i>End Date</i> are left blank, all patients will be considered for announcements.
                        </p>
                        <p>If the <i>Re-announce</i> check box is selected, patients that have previously been announced to a selected organization will be announced again.</p>
                    </div>
                    <form name="batchAnnounceForm" id="batchAnnounceForm" action="BatchAnnounce.do_sec" method="POST" enctype="multipart/form-data" class="form-horizontal" onsubmit="return isFormValid(this);">
                        <input type="hidden" name="newLeft" value="" />
                        <input type="hidden" name="remoteOrganization" value="" />
                        <div id="errorMessage" class="alert alert-danger pad-15" style="display: none;" role="alert"></div>
                        <div class="row">
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3 text-center">
                                <label for="list1" class="control-label">All Organizations</label>
                            </div>
                            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                
                            </div>
                            <div id="divList2Label" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 text-center">
                                <label for="list2" class="control-label"><f:requiredField altText="Organizations to whom you want to announce patients is a required field." labelText="Organizations to whom you want to announce patients." useNoWrap="false" /></label>
                            </div>
                        </div>
                        <div id="multiSelectAuthorizeForm" class="row pad-bottom-10">
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select title="All Organizations list box" class="listSelect form-control" name="list1" id="list1" multiple size="10" onDblClick="opt.transferRight(); validateList2();" data-tooltip="<c:out value="${descriptors['batchAnnouncePatientsAllOrganizationsField']}" />"> --%>
                                <select title="All Organizations list box" class="listSelect form-control js-simple-tooltip" name="list1" id="list1" multiple size="10" onDblClick="opt.transferRight(); validateList2();" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsAllOrganizationsField']}" />">
                                    <c:if test="${!empty organizations}">
                                        <c:forEach var="r" items="${organizations}" varStatus="i">
                                            <option value="<c:out value="${r.orgOid}" />"><c:out value="${r.orgName}" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
                                        </c:forEach>
                                    </c:if>
                                </select>
                            </div>
                            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 text-center">
                                <%-- buttons --%>
                                <%-- <button type="button" data-tooltip="<c:out value="${descriptors['batchAnnounceMoveAll']}" />" class="midButton moveButtons btn btn-primary btn-block" name="right" onclick="opt.transferAllRight()">Add All <span aria-hidden='true'>&gt;&gt;</span></button> --%>
                                <%-- <button type="button" data-tooltip="<c:out value="${descriptors['batchAnnounceMoveSelectedRight']}" />" class="midButton moveButtons btn btn-info margin-top-10 btn-block" name="right" onclick="opt.transferRight()">Add Selected <span aria-hidden='true'>&gt;</span></button> --%>
                                <%-- <button type="button" data-tooltip="<c:out value="${descriptors['batchAnnounceMoveSelectedLeft']}" />" class="midButtonLeft moveButtons btn btn-info margin-top-10 btn-block" name="left" onclick="opt.transferLeft()"><span aria-hidden='true'>&lt;</span> Remove Selected</button> --%>
                                <%-- <button type="button" data-tooltip="<c:out value="${descriptors['batchAnnounceClear']}" />" class="midButton moveButtons btn btn-default margin-top-10 btn-block" name="left" onclick="opt.transferAllLeft()">Clear</button> --%>
                                
                                <button type="button" data-simpletooltip-prefix-class="multiselect-button" data-simpletooltip-text="<c:out value="${descriptors['batchAnnounceMoveAll']}" />" class="midButton moveButtons btn btn-primary btn-block js-simple-tooltip" name="rightAll" onclick="opt.transferAllRight()">Add All <span aria-hidden='true'>&gt;&gt;</span></button>
                                <button type="button" data-simpletooltip-prefix-class="multiselect-button" data-simpletooltip-text="<c:out value="${descriptors['batchAnnounceMoveSelectedRight']}" />" class="midButton moveButtons btn btn-info margin-top-10 btn-block js-simple-tooltip" name="rightSelected" onclick="opt.transferRight()">Add Selected <span aria-hidden='true'>&gt;</span></button>
                                <button type="button" data-simpletooltip-prefix-class="multiselect-button" data-simpletooltip-text="<c:out value="${descriptors['batchAnnounceMoveSelectedLeft']}" />" class="midButtonLeft moveButtons btn btn-info margin-top-10 btn-block js-simple-tooltip" name="left" onclick="opt.transferLeft()"><span aria-hidden='true'>&lt;</span> Remove Selected</button>
                                <button type="button" data-simpletooltip-prefix-class="multiselect-button" data-simpletooltip-text="<c:out value="${descriptors['batchAnnounceClear']}" />" class="midButton moveButtons btn btn-default margin-top-10 btn-block js-simple-tooltip" name="left" onclick="opt.transferAllLeft()">Clear</button>
                            </div>
                            <div id="divList2" class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select title="Organizations to whom you want to announce patients list box" name="list2" class="listSelect form-control" multiple size="10" id="list2" onDblClick="opt.transferLeft(); validateList2();" data-tooltip="<c:out value="${descriptors['batchAnnouncePatientsOrganizationsToAnnounceToField']}" />"></select> --%>
                                <select title="Organizations to whom you want to announce patients list box, Required" name="list2" class="listSelect form-control js-simple-tooltip" multiple size="10" id="list2" onDblClick="opt.transferLeft(); validateList2();" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsOrganizationsToAnnounceToField']}" />" aria-label="Organizations to whom you want to announce patients list box, Required"></select>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-8 col-sm-8 col-md-8 col-lg-8">
                                <div class="radio">
                                    <label id="radioLabel">
                                        <%-- <input type="radio" aria-labelledby="radioLabel" id="bat1" name="batchAnnounceType" value="1" title="Batch announce patients that are opted-in" onclick="onBatchAnnounceTypeChange(this);" checked  data-tooltip="<c:out value="${descriptors['batchAnnouncePatientsOptedInField']}" />" /> --%>
                                        <input type="radio" aria-labelledby="radioLabel" id="bat1" name="batchAnnounceType" value="1" title="Batch announce patients that are opted-in" onclick="onBatchAnnounceTypeChange(this);" checked class="js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsOptedInField']}" />" />
                                        Batch announce patients that have opted-in
                                    </label>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Start Date</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control vap-datepicker-input" value="<c:out value="${startDate}" />" /> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" name="startDate" id="startDate" class="form-control vap-datepicker-input js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />" value="<c:out value="${startDate}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">End Date</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control vap-datepicker-input" value="<c:out value="${endDate}" />" /> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" name="endDate" id="endDate" class="form-control vap-datepicker-input js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />" value="<c:out value="${endDate}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4 col-xs-offset-2 col-sm-offset-2 col-md-offset-2 col-lg-offset-1">
                                <div class="checkbox">
                                    <label>
                                        <%-- <input id="reannounce" type="checkbox" name="reannounce" value="reannounce" <c:if test="${reannounce}">checked</c:if> title="Check to Reannounce" data-tooltip="<c:out value="${descriptors['reAnnounceCheckbox']}" />" /> --%>
                                        <input id="reannounce" type="checkbox" name="reannounce" value="reannounce" <c:if test="${reannounce}">checked</c:if> title="Check to Reannounce" class="js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['reAnnounceCheckbox']}" />" />
                                        Re-announce
                                    </label>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-8 col-sm-8 col-md-8 col-lg-8">
                                <div class="radio">
                                    <label id="batchAnnounceToFileLabel" for="bat2">
                                        <%-- <input type="radio" aria-labelledby="batchAnnounceToFileLabel" id="bat2" name="batchAnnounceType" value="2" onclick="onBatchAnnounceTypeChange(this);" data-tooltip="<c:out value="${descriptors['batchAnnouncePatientsInExcelOrCSVFileField']}" />" /> --%>
                                        <input type="radio" class="js-simple-tooltip" aria-labelledby="batchAnnounceToFileLabel" id="bat2" name="batchAnnounceType" value="2" onclick="onBatchAnnounceTypeChange(this);" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsInExcelOrCSVFileField']}" />" />
                                        Batch announce patients listed in an Excel or CSV file
                                    </label>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3 col-xs-offset-1 col-sm-offset-1 col-md-offset-1 col-lg-offset-1">
                                <div class="input-group" id="divFileUpload" style="z-index: 1;">
                                    <label class="input-group-btn">
                                        <span>
                                            <button type="button" class="btn btn-primary" tabindex="0" id="fileUploadButton" disabled="disabled">Browse&hellip;</button>
                                            <%-- <input type="file" id="fileName" name="fileName" style="display: none;" aria-labelledby="batchAnnounceToFileLabel" onchange="validateFileExt(this.value);" accept="application/xls,application/xlsx,text/csv" data-tooltip="<c:out value="${descriptors['batchAnnouncePatientsFileNameField']}" />" /> --%>
                                            <input type="file" id="fileName" name="fileName" style="display: none;" aria-labelledby="batchAnnounceToFileLabel" onchange="validateFileExt(this.value);" accept="application/xls,application/xlsx,text/csv" class="js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['batchAnnouncePatientsFileNameField']}" />" />
                                        </span>
                                    </label>
                                    <input type="text" id="fileNameHolder" class="form-control" style="margin-left: -3px;" aria-labelledby="batchAnnounceToFileLabel" readonly />
                                </div>
                            </div>
                            <div class="col-xs-1 col-sm-1 col-md-1 col-lg-1">
                                <button class="btn btn-default" id="btnClear" style="display: none;" onclick="clearSelectedFile();" type="button">Clear</button>
                            </div>
                        </div>     
                        <div class="form-group">
                            <div class="col-xs-8 col-sm-8 col-md-8 col-lg-8 text-right">
                                <input name="query" title="Query for the announcements" class="btn btn-primary" type="submit" value="Query"/>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </c:otherwise>
    </c:choose>
</f:mainTemplate>