<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<div id="generateLetterError" class="alert alert-danger" style="display: none;" role="alert">
    Please fix the highlighted errors.
</div>
<form id="frmGenerateLetter" name="frmGenerateLetter" class="form-horizontal" method="POST" role="form" data-toggle="validator">
    <input type="hidden" id="delayCollection" name="delayCollection" value="<c:out value="${delayedConsent.delayReasonCollection}"/>" />
    <input type="hidden" id="generateLetter" name="generateLetter" value="true" />
    <div class="form-group">
        <label for="patientName" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient</label>
        <input type="hidden" id="patientName"><%-- uh what is this??? --%>
        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
            <p class="form-control-static">
                <c:out value="${patientDemographics.firstName}" /> 
                <c:if test="${!empty patientDemographics.middleName}"><c:out value="${fn:substring(patientDemographics.middleName,0,1)}" />. </c:if>
                <c:out value="${patientDemographics.lastName}" /> 
                <c:out value="${patientDemographics.suffix}" />
            </p>
        </div>
    </div>
    <div class="form-group">
        <label for="authenticatingFacility" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Authenticating Facility is a required field." labelText="Authenticating Facility" useNoWrap="false" /></label>
        <div class="col-xs-10 col-sm-10 col-md-10 col-lg-10">
            <select id="authenticatingFacility" name="authenticatingFacility" class="form-control" required>
                <c:forEach var="f" items="${allowedFacilities}">
                    <option value="<c:out value="${f.facilityStation}"/>"
                        <c:if test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                            selected
                        </c:if>>
                        <c:choose>
                            <c:when test="${f.facilityName != ''}">
                                <c:out value="${f.facilityName}"/>
                            </c:when>
                            <c:otherwise>
                                <c:out value="${fn:split(f.facilityDns, '.')[0]}"/>
                            </c:otherwise>
                        </c:choose>
                        (<c:out value="${f.facilityStation}"/>)
                    </option>
                </c:forEach>
            </select> 
        </div>
    </div>
    <div class="form-group">
        <c:if test="${delayedConsent != null}">
            <input type="hidden" name="type" id="type" value="delayed" />
            <label for="delayReasons" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Delay Reason is a required field." labelText="Delay Reason${fn:length(delayedConsent.delayReasonCollection) > 1 ? 's': ''}" /></label>
            <div id="delays" class="form-control-static col-xs-4 col-sm-4 col-md-4 col-lg-4">
                <c:forEach var="dr" items="${delayedConsent.delayReasonCollection}">
                    <c:out value="${dr.name}"/><br />
                </c:forEach>
            </div>
        </c:if>
        <c:if test="${consent != null}">
            <c:choose>
                <c:when test="${consent.optoutDate == null}">
                    <input type="hidden" name="type" id="type" value="expiring" />
                </c:when>
                <c:otherwise>
                    <input type="hidden" name="type" id="type" value="revoked" />
                </c:otherwise>
            </c:choose>
        </c:if>
    </div>
    <div class="form-group">
        <label for="signature" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Signature is a required field." labelText="Signature" /></label>
        <div class="col-xs-10 col-sm-10 col-md-10 col-lg-10">
            <textarea id="signature" name="signature" class="form-control" rows="5" required></textarea>
        </div>
    </div>
    <div class="col-xs-offset-2 col-sm-offset-2 col-md-offset-2 col-lg-offset-2 checkbox">
        <label>
            <input type="checkbox" title="Mark as mailed" name="markMailed" id="markMailed" value="true" /> Mark as mailed
        </label>
    </div>
    <%-- <div class="form-group">
        <label for="markMailed">Mark as mailed</label>
        <input type="checkbox" title="Mark as mailed" name="markMailed" id="markMailed" value="true" style="padding-left: 50em;" /><br/><br/>
    </div> --%>
    <%-- <div>
        <center>
            <input id="Generate" class="button" type="submit" disabled="disabled" value="Generate" name="generateLetter" title="Generate" onclick='closeAndReload();'>
        </center>
    </div> --%>
</form>

<%-- <script>
    jQuery(document).ready(function () {
        //Help text for signature block.
        jQuery('#signature').attr("placeholder","First name Last name \nFacility Role \nContact Information");
    });
</script>

<div class="form-container">
    <fieldset>
        <legend>Options</legend>
        <form action="PatientDetails.do_sec" method="POST" enctype="multipart/form-data" onsubmit="return doSubmit(this)">
            <input type="hidden" id="delayCollection" name="delayCollection" value="<c:out value="${delayedConsent.delayReasonCollection}"/>" />
            <div>
                <label for="patientName">Patient</label>
                <input type="hidden" id="patientName">
                <strong>
                    <c:out value="${patientDemographics.firstName}"/> 
                    <c:if test="${!empty patientDemographics.middleName}"><c:out value="${fn:substring(patientDemographics.middleName,0,1)}"/>. </c:if>${patientDemographics.lastName} 
                    <c:out value="${patientDemographics.suffix}"/>
                </strong>
                <br /><br />
            </div>
            <div>
                <label for="authenticatingFacility">
                    Authenticating Facility
                    <img alt="Required field" src="res/star-icon_grey_bg.png" />
                </label>
                <select id="authenticatingFacility" name="authenticatingFacility" style="width: 585px; overflow: auto;">
                    <c:forEach var="f" items="${allowedFacilities}">
                        <option value="<c:out value="${f.facilityStation}"/>"
                            <c:if test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                selected
                            </c:if>>
                            <c:choose>
                                <c:when test="${f.facilityName != ''}">
                                    <c:out value="${f.facilityName}"/>
                                </c:when>
                                <c:otherwise>
                                    <c:out value="${fn:split(f.facilityDns, '.')[0]}"/>
                                </c:otherwise>
                            </c:choose>
                            (<c:out value="${f.facilityStation}"/>)
                        </option>
                    </c:forEach>
                </select> 
                <br /> <br />
            </div>
            <div>
                <c:if test="${delayedConsent != null}">
                    <input type="hidden" name="type" id="type" value="delayed" />
                    <label for="delayReasons">
                        Delay Reason<c:if test="${fn:length(delayedConsent.delayReasonCollection) > 1}">s</c:if>: 
                    </label>
                    <div style="display:inline-block" id="delays">
                        <c:forEach var="dr" items="${delayedConsent.delayReasonCollection}">
                            <c:out value="${dr.name}"/>&nbsp;<br />
                        </c:forEach>
                    </div>
                </c:if>
                <c:if test="${consent != null}">
                    <c:choose>
                        <c:when test="${consent.optoutDate == null}">
                            <input type="hidden" name="type" id="type" value="expiring"/>
                        </c:when>
                        <c:otherwise>
                            <input type="hidden" name="type" id="type" value="revoked" />
                        </c:otherwise>
                    </c:choose>
                </c:if>
            </div>
            <div>
                <br />
                <label for="signature">
                    Signature
                    <img alt="Required field" src="res/star-icon_grey_bg.png" />
                </label>
                <textarea id="signature" name="signature" onkeyup="enableLetterGenerate('signature');" style="width: 300px; height: 60px;"></textarea>
                <br /><br />
                <label for="markMailed">Mark as mailed</label>
                <input type="checkbox" title="Mark as mailed" name="markMailed" id="markMailed" value="true" style="padding-left: 50em;" /><br/><br/>
            </div>
            <div>
                <center>
                    <input id="Generate" class="button" type="submit" disabled="disabled" value="Generate" name="generateLetter" title="Generate" onclick='closeAndReload();'>
                </center>
            </div>
        </form>
    </fieldset>
</div> --%>