<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@page import="java.util.HashMap"%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
%> 

<f:mainTemplate headerText="Expiring Consent Report">
    <script type="text/javascript">
        $(document).ready(function () {
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });

            //handler for confirm download of patient letter(s)
            $('#confirmPatientLetterDownloadModalDownload').on('click', function(){
                if(!$(this).hasClass('disabled')){
                    window.location.replace(downloadLetters());
                }
            });

            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
            
            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                ajax: {
                    url: VAP.common.constructUrl('doSearch'),
                    dataSrc: function (json) {
                        $('#totalRows').val(json.rowTotalForLetters);
                        $('#expiredNotificationLettersMaxTime').val(json.expiredNotificationLettersMaxTime);
                        $('#expiredNotificationPerLetterTime').val(json.expiredNotificationPerLetterTime);

                        //change button availability based on displayed table
                        if ($('#consentTypeName').val() === 'NwHIN Authorization' && $.trim(json.oneStationRequested) === 'true' && json.rowTotalForLetters > 0) {
                            //all good, enable download and change the message to show that
                            $('#confirmPatientLetterDownloadModalDownload').removeClass('disabled');
                            $('#confirmPatientLetterDownloadModalLabel').html('Confirm Download');
                            $('#confirmPatientLetterDownloadModalBody').html('It may take up to a second per record to generate patient notification letters. Do you wish to continue?');
                        } else if ($('#consentTypeName').val() !== 'NwHIN Authorization' && $.trim(json.oneStationRequested) === 'true') {
                            $('#confirmPatientLetterDownloadModalDownload').addClass('disabled');
                            $('#confirmPatientLetterDownloadModalLabel').html('Download Not Available');
                            $('#confirmPatientLetterDownloadModalBody').html('Please filter by only eHealth Exchange Authorizations to enable PDF generation.');
                        } else {
                            $('#confirmPatientLetterDownloadModalDownload').addClass('disabled');
                            $('#confirmPatientLetterDownloadModalLabel').html('Download Not Available');
                            $('#confirmPatientLetterDownloadModalBody').html('Please filter by exactly one facility to enable PDF generation');
                        }
                        return json.data;
                    }
                },
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                serverSide: true,
                processing: true,
                searching: false,
                lengthMenu: [10, 25, 50, 100, 250, 500],
                columnDefs: [
                    {
                        targets: 0,
                        data: null,
                        render: function (data, type, full, meta) {
                            return '<a href="#/" onclick="linkToPatient(\'' + data[9] + '\', \'' + data[1] + '\', \'' + data[2] + '\');">' + data[0] + '</a>';
                        }
                    },
                    {className: "vap-col-min-80", targets: 0},
                    {className: "vap-col-min-200", targets: [6, 8]},
                    {className: 'text-center vertical-align-center', targets: [9]},
                    {
                        targets: 9,
                        data: null,
                        render: function (data, type, full, meta) {
                            if (data[11] && "true" === data[11]) {
                                return '<a class="btn btn-xs btn-primary" href="#/" onclick="documentView(\'' + data[10] + '\');">View</a>';
                            } else {
                                return "";
                            }
                        }
                    },
                    {orderable: false, targets: [9]}
                ],
                pageLength: 25,
                order: [[4, "desc"]]
            });

            // DataTable overrides
            $.fn.dataTable.ext.errMode = 'none';

            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });

            function downloadLetters() {
                var url = VAP.common.constructUrl("download");
                //add extra parameters
                url = url + '&totalRows=' + $('#totalRows').val() +
                        '&expiredNotificationLettersMaxTime=' + $('#expiredNotificationLettersMaxTime').val() +
                        '&expiredNotificationPerLetterTime=' + $('#expiredNotificationPerLetterTime').val();
                return url;
            };

            $('#searchButton').on('click', function () {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();

                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate, true);

                if (errorMessage !== '')
                {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
                }
            });

            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            $('#results').hide();
            
            //set up JSON to pass to the Advanced Scheduling modal/functionality
            $('#btnScheduleExport').on('click', function(){
                //have to do a little work to get the values of the Authenticating Facilities 
                var selectArrValues = []; 
                
                $('#fd-selectedFacilities option').each(function() {
                    selectArrValues.push($(this).val());
                });
                
                //set up array of items to view at the top of the schedule export modal
                var viewParameters = [ 
                    {name : 'Consent Type', value : $('#consentTypeName option:selected').text()},
                    {name : 'Entered By', value : $('#enteredBy option:selected').text()},
                    {name : 'Patient Types', value : $('#patientTypes option:selected').text()},
                    {name : 'Authenticating Facilities', value : selectArrValues}
                ];

                //set up array of items to pass as JSON in the schedule export modal form
                var parameters = {
                    'consentTypeName' : $('#consentTypeName').val(),
                    'enteredBy' : $('#enteredBy').val(),
                    'patientTypes' : $('#patientTypes').val(),
                    'stationNumbers' : facilitiesDialog.getSelectedStationNumbers(),
                    'includeUnknownVisn' : facilitiesDialog.getIncludeUnknownVisn()
                };

                VAP.common.advancedSchedulingPopulateScheduleParameters(viewParameters, parameters, 'Expiring Consent Report');
            });
        });
        
        VAP.common.constructUrl = function(methodName) {
            var url = 'ExpiringConsentReport.do_sec?' + methodName + '=true' +
                '&startDate=' + $('#startDate').val() +
                '&endDate=' + $('#endDate').val() +
                '&enteredBy=' + $('#enteredBy').val() +
                '&patientTypes=' + $('#patientTypes').val() +
                '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
                '&consentTypeName=' + $('#consentTypeName').val() +
                '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
                '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1];

            if (methodName === 'exportToCsv' || methodName === 'exportToExcel') {
                url = url + '&totalRows=' + VAP.common.reportTable.page.info().recordsTotal;
            }

            return url;
        };
        
        // Used by 'view' link in the last column
        function documentView(documentUniqueId){
            $('#documentUniqueId').val(documentUniqueId);
            document.getElementById('documentViewForm').submit();
        }
    </script>

    <cpp:errors />

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12"> 
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Search Criteria" aria-label="Search Criteria" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myReportSearchPanel"></i></a> Search Criteria
                    </div> 
                </div>   
                <div class="panel-body" id="myReportSearchPanel"> 
                    <div class="alert alert-info">
                        Fill in the fields below to narrow your search.
                    </div>
                    <div id="userScheduledExportModalMessage" class="alert alert-dismissible" role="alert" style="display: none;">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    </div>
                    <form name="expiringConsentReportForm" id="expiringConsentReportForm" class="form-horizontal">
                        <fieldset>
                            <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                            <div class="form-group">
                                <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                                <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                    <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateString}" />" /> --%>
                                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                    <input type="text" name="startDate" id="startDate" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />" value="<c:out value="${startDateString}" />" />
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                                <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                    <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateString}" />" /> --%>
                                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                    <input type="text" name="endDate" id="endDate" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />" value="<c:out value="${endDateString}" />" />
                                </div>
                            </div>
                            <jsp:include page="reporting/common/facilitiesFilter.jsp">
                                <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                                <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                                <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                                <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                            </jsp:include>
                            <div class="form-group">
                                <label class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="consentTypeName">Consent Type<span style="display:none;">"Query based on consent type from the dropdown list"</span></label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <%-- <select class="form-control" id="consentTypeName" name="consentTypeName" data-tooltip="<c:out value="${descriptors['consentTypeField']}"/>"> --%>
                                    <select class="form-control js-simple-tooltip" id="consentTypeName" name="consentTypeName" data-simpletooltip-text="<c:out value="${descriptors['consentTypeField']}"/>">
                                        <option value="" selected>ALL Authorizations</option>
                                        <option value="NwHIN Authorization"><c:out value="${organizationName}" /> Authorizations</option>
                                        <option value="SSA Authorization">SSA Authorizations</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="enteredBy">Entered By<span style="display:none;">"Query based on whom entered information from the dropdown list"</span></label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <%-- <select class="form-control" id="enteredBy" name="enteredBy" data-tooltip="<c:out value="${descriptors['enteredByField']}"/>"> --%>
                                    <select class="form-control js-simple-tooltip" id="enteredBy" name="enteredBy" data-simpletooltip-text="<c:out value="${descriptors['enteredByField']}"/>">
                                        <option value="" selected>ALL</option>
                                        <option value="eBenefits">eBenefits</option>
                                        <option value="employee">Employee</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="patientTypes">Patient Types<span style="display:none;">"Choose whether you would like to filter by real patients only, test patients only, or both."</span></label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <%-- <select class="form-control" id="patientTypes" name="patientTypes" data-tooltip="<c:out value="${descriptors['patientTypesField']}"/>"> --%>
                                    <select class="form-control js-simple-tooltip" id="patientTypes" name="patientTypes" data-simpletooltip-text="<c:out value="${descriptors['patientTypesField']}"/>">
                                        <option value="3">ALL</option>
                                        <option value="1" selected>Real Patients</option>
                                        <option value="2">Test Patients</option>
                                    </select>
                                </div>
                            </div>
                        </fieldset>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                            <cpp:userInRole role="VAPApplicationWebAdministrator">
                                <button name="btnScheduleExport" id="btnScheduleExport" class="btn btn-default" data-toggle="modal" data-target="#scheduleExportModal" title="Schedule" aria-label="Schedule">Schedule</button>
                            </cpp:userInRole>
                            <input name="search" title="Search" class="btn btn-primary" type="button" value="Search" id="searchButton" />
                        </div>
                    </div>                
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-heading">
                <div class="panel-title">
                    <div class="pull-left">
                        <a href="#" title="Search Results" aria-label="Search Results" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myResultsPanel"></i></a> Search Results
                    </div>
                    <div class="pull-right"><!-- right align the buttons -->
                        <a href="#results" id="downloadButton" data-toggle="modal" data-target="#confirmPatientLetterDownloadModal" name="download" title="Download Patient Notification Letters" role="button" class="pad-right-10 disabled"><i class="fa fa-download" aria-hidden="true"></i> Download Patient Notification Letters</a>
                        <a href="#results" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                        <a href="#results" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToCsv" title="Export to CSV" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to CSV</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
            </div>   
            <div class="panel-body" id="myResultsPanel">
                <div id="divReportContent">
                    <%@include file="patientLinkForm.jsp"%>
                    <form action="OptInOptOutReport.do_sec" method="POST" onsubmit="return doSubmit(this)" id="documentViewForm">
                        <input type="hidden" name="view" value="true"> 
                        <input type="hidden" name="documentUniqueId" value="" id="documentUniqueId">
                    </form>
                    <form style="display: inline-block;">
                        <input type="hidden" name="totalRows" id="totalRows" value="">
                        <input type="hidden" name="expiredNotificationLettersMaxTime" id="expiredNotificationLettersMaxTime" value="">
                        <input type="hidden" name="expiredNotificationPerLetterTime" id="expiredNotificationPerLetterTime" value="">
                    </form>
                    <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                        <thead>
                            <tr role="row">
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['ssnColumn']}"/>" id="ssnHeader">SSN</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['lastNameColumn']}"/>" id="lastNameHeader">Patient Last Name</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['firstNameColumn']}"/>" id="firstNameHeader">Patient First Name</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['middleNameColumn']}"/>" id="middleNameHeader">Patient Middle Name</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['optInDateColumn']}"/>" id="optInDateHeader">Opt In Date</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['expirationDateColumn']}"/>" id="expDateHeader">Expiration Date</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['expiringConsentDetailedReportConsentTypeColumn']}"/>" id="consentTypeHeader">Consent Type</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['enteredByManualOrSystemColumn']}"/>" id="enteredByHeader">Entered By</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['authenticatingFacilityColumn']}"/>" data-tooltip-position="left" id="authFacilityHeader">Authenticating Facility</span></th> --%>
                                <%-- <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['genericViewColumn']}"/>" data-tooltip-position="left">View</span></th> --%>
                                
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['ssnColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="ssnHeader" data-simpletooltip-target="tableheader">SSN</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['lastNameColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="lastNameHeader" data-simpletooltip-target="tableheader">Patient Last Name</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['firstNameColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="firstNameHeader" data-simpletooltip-target="tableheader">Patient First Name</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['middleNameColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="middleNameHeader" data-simpletooltip-target="tableheader">Patient Middle Name</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['optInDateColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="optInDateHeader" data-simpletooltip-target="tableheader">Opt In Date</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['expirationDateColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="expDateHeader" data-simpletooltip-target="tableheader">Expiration Date</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['expiringConsentDetailedReportConsentTypeColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="consentTypeHeader" data-simpletooltip-target="tableheader">Consent Type</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['enteredByManualOrSystemColumn']}"/>" data-simpletooltip-prefix-class="secondary"><span id="enteredByHeader" data-simpletooltip-target="tableheader">Entered By</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['authenticatingFacilityColumn']}"/>" data-simpletooltip-prefix-class="secondary-left"><span id="authFacilityHeader" data-simpletooltip-target="tableheader">Authenticating Facility</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['genericViewColumn']}"/>" data-simpletooltip-prefix-class="secondary-left"><span data-simpletooltip-target="tableheader">View</span></th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div> 
    </div>
    <!-- modal div for download letter alert -->
    <div class="modal fade" id="confirmPatientLetterDownloadModal" role="dialog" data-backdrop="static" aria-labelledby="confirmPatientLetterDownloadModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-sm vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="confirmPatientLetterDownloadModalLabel">Confirm Download</h4>
                    </div>
                    <div class="modal-body" id="confirmPatientLetterDownloadModalBody">
                        
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="confirmPatientLetterDownloadModalCancel" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="confirmPatientLetterDownloadModalDownload" class="btn btn-primary" data-dismiss="modal">Download</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    
    <%-- adding the advanced scheduling option to this report --%>
    <cpp:advancedScheduling />
</f:mainTemplate>