<%--
    Document   : Patient View C32 View
    Created By : David Vasquez / Robert Snelling
    Modified By: Asha Amritraj
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<f:mainTemplate headerText="">
    <link rel="stylesheet" type="text/css" href="resources/css/c32/xmlverbatim.css" />
    <link rel="stylesheet" type="text/css" href="resources/css/c32/cda.css" />
    <link rel="stylesheet" type="text/css" href="resources/css/c32/adapter.css" />
    <link rel="stylesheet" type="text/css" href="resources/css/c32/custom_cda.css" />
    
    <div class="row pad-bottom-20">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" role="navigation">
            <ul class="nav nav-tabs">
                <li role="presentation"><a href="PatientDetails.do_sec?show=true" aria-label="Patient Summary tab, inactive">Patient Summary</a></li>
                <li role="presentation" class="active"><a href="#" aria-label="Health Summary (C32) tab, active">Health Summary (C32)</a></li>
                <li role="presentation"><a href="PatientDetails.do_sec?viewCCDA=true" aria-label="Health Summary (C-CDA) tab, inactive">Health Summary (C-CDA)</a></li> 
            </ul>
        </div>
    </div>
    <div class="text-right pad-bottom-20">
        <cpp:userInRole role="VAPApplicationTester">
            <c:if test="${isXmlViewEnabled}">
                <a title="View XML" href="PatientDetails.do_sec?view=true&styleSheetViewType=xml" class="no-print"><i class="fa fa-file-text-o fa-2x" aria-hidden="true"></i> View XML</a>
            </c:if>
        </cpp:userInRole>
        <a title="Print Document" href="javascript:window.print()" class="no-print"><i class="fa fa-print fa-2x" aria-hidden="true"></i> Print</a>
    </div>
    <div class="pad-bottom-20">
        <!-- document goes here -->
        <c:out value="${updatedDocument}" escapeXml="false"/>
    </div>
</f:mainTemplate>
