<%-- 
    Document   : patientDetails take 2 or 3 or maybe 10
    Created on : Jan 24, 2017, 12:36:43 PM
    Author     : Johann Sonnenberg
--%>
<%@page import="java.text.SimpleDateFormat"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<%
    // Don't do this in a JSP Declaration (with exclamation point);
    // not thread safe, and it will be the wrong end date within 24 hours after
    // the page is first accessed.
    // Have to set request attributes to use in Expression Language.
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    request.setAttribute("reportEndDate", ft.format(new Date( ))) ;
    request.setAttribute("reportStartDate", "01/01/1900");
%>  

<f:mainTemplate headerText="">
    <script type="text/javascript" src="resources/js/OptionTransfer.js"></script>
    <script language="JavaScript">
        $(document).ready(function () {
            //initial data table setup and call for the first recordset
            
            //comments table setup
            var commentTable = $('#tblComments').DataTable({
                destroy: true, 
                searching: false,
                processing: true,
                serverSide: true,
                order: [0],
                columnDefs: [
                    {orderable: false, targets: [0,1,2]},
                    {className: "vap-white-space-pre-wrap", targets: 2}
                ],
                //ajax: "PatientDetails.do_sec?getPatientComments=true",
                ajax: { 
                    url: 'PatientDetails.do_sec?getPatientComments=true',
                    dataSrc: function(json){
                        $('#tblComments .dataTables_empty').remove();
                        VAP.common.reportNoRecordsMessage = 'No comments found at this time.';
                        return json.data;
                    },
                    error: function(o){
                        VAP.common.handleErrorsInDataTable('tblComments', o, 2, 'divCommentsPanel');
                    }
                }, 
                paging: true,
                info: true,
                lengthMenu: [ 5, 10, 25, 50, 100, 250, 500 ],
                pageLength: 5
            });
            
            VAP.common.setProcessingForDataTable('tblComments', 'divCommentsPanel');
            
            commentTable.on('draw', function () {
                VAP.common.addAriaToDataTable('tblComments', commentTable);
            });
            
            VAP.common.reportNoRecordsMessage = "This patient has no <c:out value="${organizationName}" /> correlations.";
            
            //correlations table setup
            var correlationsTable = $('#tblCorrelations').DataTable({
                searching: false,
                processing: true,
                serverSide: false,
                order:[0],
                columnDefs: [
                    {orderable: false, targets: [0,1,2,3]}
                ],
                paging: true,
                info: true,
                lengthMenu: [ 5, 10, 25, 50, 100, 250, 500 ],
                pageLength: 5
            });
            
            VAP.common.setProcessingForDataTable('tblCorrelations');
            VAP.common.addAriaToDataTable('tblCorrelations', correlationsTable);
            
            correlationsTable.on('draw', function () {
                //VAP.common.reportNoRecordsMessage = "This patient has no <c:out value="${organizationName}" /> correlations.";
            });
            
            
            
            //consent (status) history table setup (no ajax call for this table, just styling it will DataTables)
            var consentHistoryTable = $('#tblConsentHistory').DataTable({
                searching: false,
                processing: true,
                serverSide: false,
                order: [[3, 'desc']],
                ordering: false, 
                /*columnDefs: [
                    {orderable: false, targets: [0,1,2,3,4,5,6,7,8,9,10,11]}
                ],*/
                paging: false,
                info: false
            });
            
            VAP.common.setProcessingForDataTable('tblConsentHistory');
            
            // We can attach the 'fileselect' event to all file inputs on the page
            $(document).on('change', ':file', function() {
                var input = $(this),
                numFiles = input.get(0).files ? input.get(0).files.length : 1,
                label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
                input.trigger('fileselect', [numFiles, label]);
            });

            // We can watch for our custom 'fileselect' event like this
            $(':file').on('fileselect', function(event, numFiles, label) {
                var input = $(this).parents('.input-group').find(':text'),
                log = numFiles > 1 ? numFiles + ' files selected' : label;

                if( input.length ) {
                    input.val(log);
                } else {
                    if( log ) alert(log);
                }
            });
            
            //handlers
            
            //patient comment add
            $('#btnPatientCommentSubmit').on('click', function () {
                if ($('#patientCommentForm').validator('validate').has('.has-error').length) {
                    // handle the invalid form...
                    $('#patientCommentError').show();
                } else {
                    $.ajax({
                        url: "PatientDetails.do_sec?addPatientComment=true",
                        headers: { 'skipLoadingAlert' : 'true' },
                        data: {
                            patientIen: $('#patientIen').val(),
                            patientComments: $('#patientComments').val()
                        },
                        success: function (result) {
                            //refresh the patient comments table
                            commentTable.ajax.url("PatientDetails.do_sec?getPatientComments=true").load();

                            //show the success message
                            $('#patientCommentMessage').show().delay(5000).slideUp();
                            
                            $('#patientCommentModal').modal('hide');
                        }
                    });
                }
            });
            
            //on load of the patient comment add modal, blank out the comments just in case there were any previous comments created, hide the error message if it is shown, and reset the validator for the form
            $('#patientCommentModal').on('show.bs.modal', function(event) {
                $('#patientCommentError').hide();
                $('#patientComments').val('');
                $('#patientCommentForm').validator('destroy');
                $('#patientCommentForm').validator('update');
            });
            
            //generate letter modal
            $('#printLetterModal').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var consentId = button.data("consent-id");
                var delayedConsentId = button.data("delayed-consent-id");
                var urlAddons = '';
                
                if (typeof delayedConsentId != 'undefined'){
                    urlAddons += '&eheDelay=true&delayedConsentId=' + delayedConsentId;
                }
                
                if (typeof consentId != 'undefined'){
                    urlAddons += '&consentId=' + consentId;
                }
                
                var url = 'PatientDetails.do_sec?printLetter=true' + urlAddons;
                var modalBody = $(this).find('.modal-body');
                
                $.ajax({
                    url: url, 
                    //data: {spinnerTargetElement : 'printLetterModalBody'},
                    spinnerTargetElement : 'printLetterModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                    
                    $('#frmGenerateLetter').validator();
                });
                
                //modalBody.load(url, {spinnerTargetElement : 'printLetterModalBody'});
            });
            
            //generate the letter
            $('#btnPrintLetterSubmit').on('click', function(e){
                if ($('#frmGenerateLetter').validator('validate').has('.has-error').length) {
                    // handle the invalid form...
                    $('#generateLetterError').show();
                } else {
                    // everything looks good!
                    $('#frmGenerateLetter').submit();
                    $('#printLetterModal').modal('hide');
                }
            });
            
            //mail dates modal
            $('#mailDateModal').on('show.bs.modal', function(event) {
                var button = $(event.relatedTarget);
                var delayedConsentId = button.data('delayed-consent-id');
                var consentDirId = button.data('consent-dir-id');
                var urlAddons = '';
                
                if (typeof delayedConsentId != 'undefined'){
                    urlAddons += '&delayedConsentId=' + delayedConsentId;
                }
                
                if (typeof consentDirId != 'undefined'){
                    urlAddons += '&consentDirId=' + consentDirId;
                }
                
                var url = 'PatientDetails.do_sec?editMailDatesForm=true' + urlAddons;
                var modalBody = $(this).find('.modal-body');
                
                //put the id of the div to update into an attribute in the Save button
                var mailDatesDiv = button.data('mail-date-div');
                $('#btnMailDateSubmit').attr('data-mail-date-div',mailDatesDiv);
                
                $.ajax({
                    url: url, 
                    spinnerTargetElement : 'mailDateModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                });
                
                //modalBody.load(url, {spinnerTargetElement : 'mailDateModalBody'});
            });
            
            //update the mail dates
            $('#btnMailDateSubmit').on('click', function(event){
                var isValid = true;
                //hide the error message in case it was showing
                $('#mailDatesErrorMessage').hide();

                //loop over all the mailDates and check each one for being valid
                $('.useDate').each(function () {
                    if ($(this).val().length > 0 && !VAP.common.isDate($(this).val())) {
                        $('#mailDatesErrorMessage').html("You entered an invalid date: " + $(this).val());
                        $('#mailDatesErrorMessage').show();
                        isValid = false;
                        return false;
                    }
                });

                //Disallow duplicate dates
                var uniqueDates = {};
                $('.useDate').each(function () {
                    if ($(this).val() !== "") {
                        var date = new Date($(this).val());
                        var date = (date.getMonth() + 1) + '/' + date.getDate() + '/' + date.getFullYear();
                        if (uniqueDates[date] === undefined) {
                            uniqueDates[date] = $(this).val();
                        } else {
                            $('#mailDatesErrorMessage').html('You have entered a duplicate date: ' + date);
                            $('#mailDatesErrorMessage').show();
                            isValid = false;
                            return false;
                        }
                    }
                });
                
                if (isValid) {
                    //all good so let's make the ajax call
                    var formData = $('#mailDatesForm').serialize();
                    $.ajax({
                        url: "PatientDetails.do_sec?editMailDates=true",
                        headers: { 'skipLoadingAlert' : 'true' },
                        data: formData,
                        success: function (results) {
                            //refresh the mail dates for this row
                            var mailDateDivToUpdate = $('#btnMailDateSubmit').attr('data-mail-date-div');
                            
                            var dates = $.parseJSON(results).data;
                            var datesHTML = '';
                            
                            $(dates).each(function(index, mailDate){
                                datesHTML += '' + mailDate + '<br />';
                            });
                            
                            $('#' + mailDateDivToUpdate).html(datesHTML);
                            
                            //hide the modal
                            $('#mailDateModal').modal('hide');

                            //show the success message
                            $('#mailDatesMessage').show().delay(5000).slideUp();
                        }
                    });
                }
            });
            
            //add consent comment modal
            $('#consentCommentModal').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var delayedConsentId = button.data('delayed-consent-id');
                var consentDirId = button.data('consent-dir-id');
                var consentType = button.data('consent-type');
                var urlAddons = '&consentType=' + encodeURI(consentType);
                
                if (typeof delayedConsentId != 'undefined'){
                    urlAddons += '&delayedConsentId=' + delayedConsentId;
                }
                
                if (typeof consentDirId != 'undefined'){
                    urlAddons += '&consentId=' + consentDirId;
                }
                
                var url = 'PatientDetails.do_sec?addCommentForm=true' + urlAddons;
                var modalBody = $(this).find('.modal-body');
                
                //put the id of the div to update into an attribute in the Save button
                var divToUpdate = button.data('consent-comment-div');
                $('#btnConsentCommentSubmit').attr('data-consent-comment-div',divToUpdate);
                
                $.ajax({
                    url: url, 
                    spinnerTargetElement : 'consentCommentModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                    
                    $('#commentForm').validator();
                });
                
                //modalBody.load(url, {spinnerTargetElement : 'consentCommentModalBody'});
            });
            
            //add consent comment submit
            $('#btnConsentCommentSubmit').on('click', function(event){ 
                $('#addConsentCommentErrorMessage').hide();
                
                if ($('#commentForm').validator('validate').has('.has-error').length) {
                    // handle the invalid form...
                    $('#addConsentCommentErrorMessage').html('Comments are required.');
                    $('#addConsentCommentErrorMessage').show();
                } else {
                    // everything looks good!
                    var formData = $('#commentForm').serialize();
                    
                    $.ajax({
                        url: "PatientDetails.do_sec?addComment=true",
                        headers: { 'skipLoadingAlert' : 'true' },
                        data: formData,
                        success: function (results) {
                            //refresh the consent comments for this row
                            var divToUpdate = $('#btnConsentCommentSubmit').attr('data-consent-comment-div');
                            
                            var comments = $.parseJSON(results).data;
                            var commentsHTML = '';
                            
                            //pull in all the proper parts of the comment - date/time, user, and the comment itself
                            $(comments).each(function(index, comment){
                                commentsHTML += '<p style="white-space: pre-wrap;">' + comment[0] + ' <b>' + comment[1] + '</b>: ' + comment[2] + '</p>';
                            });
                            
                            $('#' + divToUpdate).html(commentsHTML);
                            
                            //hide the modal
                            $('#consentCommentModal').modal('hide');

                            //show the success message
                            $('#consentCommentMessage').show().delay(5000).slideUp();
                        }
                    });
                }
            });
            
            // revoke NwHIN modal
            $('#revokeNwHINModal').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var consentType = button.data('consentType');
                $(this).data("consentType", consentType);
                if(consentType === 'wft') {
                    $('#btnRevokeNwHINModalSubmit').text('Rescind Opt-Out');
                } else {
                    $('#btnRevokeNwHINModalSubmit').text('Revoke');
                }
                var title = button.data('title');
                if(title) { // maybe override
                    $(this).find('.modal-title').text(title);
                }
                
                $.ajax({
                    url: 'PatientDetails.do_sec?revokeNwHIN=true&consentTypeShort=' + consentType, 
                    spinnerTargetElement : 'revokeNwHINModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    $('#revokeNwHINModalBody').html(data);
                    
                    $('#commentForm').validator();
                });
                
                //console.log('Launched with consent type: ' + consentType);
                //$('#revokeNwHINModalBody').load('PatientDetails.do_sec?revokeNwHIN=true&consentTypeShort=' + consentType, {spinnerTargetElement : 'revokeNwHINModalBody'});
            });

            //handle submit of the revoke NwHIN form
            $('#btnRevokeNwHINModalSubmit').on('click', function(event){
                $('#revokeNwHINErrorMessage').hide();
                //validate the form
                if ($('#frmRevokeNwHIN').validator('validate').has('.has-error').length) {
                    //we have errors
                    $('#revokeNwHINErrorMessage').html('Required fields are not complete.');
                    $('#revokeNwHINErrorMessage').show();
                } else {
                    //so we have to do the below because hidden divs (and the inputs inside them) are not passed to the servlet. so this will create the necessary inputs with values.
                    var reason = $('#reason').val();
                    if (reason != 'Revoked' && reason != 'New Authorization') {
                        var signatureDateHolder = $('#signatureDateHolder');
                        var currentDate = new Date();
                        signatureDateHolder.val(currentDate.getMonth() + 1 + "/" + currentDate.getDate() + "/" + currentDate.getFullYear());
                        signatureDateHolder.attr('name', 'signatureDate');
                        signatureDateHolder.attr('id', 'signatureDate');
                    }
                    
                    if (reason != 'Patient Deceased') {
                        var deceasedDateHolder = $('#deceasedDateHolder');
                        var currentDate = new Date();
                        deceasedDateHolder.val(currentDate.getMonth() + 1 + "/" + currentDate.getDate() + "/" + currentDate.getFullYear());
                        deceasedDateHolder.attr('name', 'deceasedDate');
                        deceasedDateHolder.attr('id', 'deceasedDate');
                    }
                    
                    //all good!
                    $('#frmRevokeNwHIN').submit();
                    
                    //hide the modal
                    $('#revokeNwHINModal').modal('hide');
                }
            });
        
            $('#authorizeNwHINModal').on('show.bs.modal', function(event){
                var button = $(event.relatedTarget);
                var consentType = button.data('consentType');
                if(consentType === 'wft') {
                    $('#btnAuthorizeNwHINModalSubmit').text('Opt-Out');
                } else {
                    $('#btnAuthorizeNwHINModalSubmit').text('Authorize');
                }
                var title = button.data('title');
                if(title) { // maybe override
                    $(this).find('.modal-title').text(title);
                }
                var modalBody = $(this).find('.modal-body');
                
                $.ajax({
                    url: 'PatientDetails.do_sec?authorizeNwHIN=true&consentTypeShort=' + consentType, 
                    spinnerTargetElement : 'authorizeNwHINModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                });
                
                //modalBody.load('PatientDetails.do_sec?authorizeNwHIN=true&consentTypeShort=' + consentType, {spinnerTargetElement : 'authorizeNwHINModalBody'});
            });

            $('#btnAuthorizeNwHINModalSubmit').on('click', function(event){
                //hide and clear the error message
                $('#authorizeNwHINErrorMessage').hide();
                $('#authorizeNwHINErrorMessage').html(''); //clear the error message
                
                //check to make sure all required fields are good
                updateAuthNwHINRequiredFields();
                
                //change up the method hidden attribute to a different name so we know which servlet method to go to
                if($('#delayedValue').prop('checked')){
                    $('#method').attr('name', 'delayAuthorization');
                } else {
                    $('#method').attr('name', 'optIn');
                }
                
                //validate the form
                if ($('#frmAuthorizeNwHIN').validator('validate').has('.has-error').length) {
                    //we have errors
                    $('#authorizeNwHINErrorMessage').prepend('Required fields are not complete.'); //prepend it because maybe we are in defered and that error message has already been aded to the error message
                    $('#authorizeNwHINErrorMessage').show();
                } else {
                    //all good!
                    $('#frmAuthorizeNwHIN').submit();
                    
                    //hide the modal
                    $('#authorizeNwHINModal').modal('hide');
                }
            });
            
            //auth delayed consent
            $('#authorizeDelayNwHINModal').on('show.bs.modal', function(event){
                var button = $(event.relatedTarget);
                var consentType = button.data('consentType');
                if(consentType === 'wft') {
                    $('#btnAuthorizeDelayNwHINModalSubmit').text('Opt-Out');
                }
                var title = button.data('title');
                if(title) { // maybe override
                    $(this).find('.modal-title').text(title);
                }
                var modalBody = $(this).find('.modal-body');
                var delayedConsentId = button.data('delayed-consent-id');
                
                $.ajax({
                    url: 'PatientDetails.do_sec?authorizeDelayNwHIN=true&delayedConsentId=' + delayedConsentId + '&consentTypeShort=' + consentType, 
                    spinnerTargetElement : 'authorizeDelayNwHINModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                });
                
                //modalBody.load('PatientDetails.do_sec?authorizeDelayNwHIN=true&delayedConsentId=' + delayedConsentId + '&consentTypeShort=' + consentType, {spinnerTargetElement : 'authorizeDelayNwHINModalBody'});
            });
            
            $('#btnAuthorizeDelayNwHINModalSubmit').on('click', function(event){
                //hide and clear the error message
                $('#authorizeNwHINErrorMessage').hide();
                $('#authorizeNwHINErrorMessage').html(''); //clear the error message
                
                //check to make sure all required fields are good
                updateAuthNwHINRequiredFields();
                
                //change up the method hidden attribute to a different name so we know which servlet method to go to
                if($('#delayedValue').prop('checked')){
                    $('#method').attr('name', 'delayAuthorization');
                } else {
                    $('#method').attr('name', 'optIn');
                }
                
                //validate the form
                if ($('#frmAuthorizeNwHIN').validator('validate').has('.has-error').length) {
                    //we have errors
                    $('#authorizeNwHINErrorMessage').prepend('Required fields are not complete.'); //prepend it because maybe we are in defered and that error message has already been aded to the error message
                    $('#authorizeNwHINErrorMessage').show();
                } else {
                    //all good!
                    $('#frmAuthorizeNwHIN').submit();
                    
                    //hide the modal
                    $('#authorizeDelayNwHINModal').modal('hide');
                }
            });
            
            //cancel delayed consent 
            $('#cancelDelayedAuthorizationModal').on('show.bs.modal', function(event){
                var button = $(event.relatedTarget);
                var consentType = button.data('consentType');
                if(consentType === 'wft') {
                    $('#btnCancelDelayedAuthorizationModalSubmit').text('Cancel Opt-Out');
                }
                var title = button.data('title');
                if(title) { // maybe override
                    $(this).find('.modal-title').text(title)
                }
                var modalBody = $(this).find('.modal-body');
                var delayedConsentId = button.data('delayed-consent-id');
                
                $.ajax({
                    url: 'PatientDetails.do_sec?cancelDelayedAuthorization=true&delayedConsentId=' + delayedConsentId + '&consentTypeShort=' + consentType,
                    spinnerTargetElement : 'cancelDelayedAuthorizationModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                });
                
                //modalBody.load('PatientDetails.do_sec?cancelDelayedAuthorization=true&delayedConsentId=' + delayedConsentId + '&consentTypeShort=' + consentType, {spinnerTargetElement : 'cancelDelayedAuthorizationModalBody'});
            });
            
            $('#btnCancelDelayedAuthorizationModalSubmit').on('click', function(event){
                //hide the error message
                $('#cancelDelayedAuthorizationErrorMessage').hide();
                
                //validate the form
                if ($('#cancelDelayForm').validator('validate').has('.has-error').length) {
                    //we have errors
                    $('#cancelDelayedAuthorizationErrorMessage').html('A comment is required.');
                    $('#cancelDelayedAuthorizationErrorMessage').show();
                } else {
                    //all good!
                    $('#cancelDelayForm').submit();
                    
                    //hide the modal
                    $('#cancelDelayedAuthorizationModal').modal('hide');
                }
            });
            
            //modifyRestrictionsModal
            $('#modifyRestrictionsModal').on('show.bs.modal', function(event){
                var modalBody = $(this).find('.modal-body');
                
                $.ajax({
                    url: 'PatientDetails.do_sec?modifyNwHINOrganizationRestrictions=true',
                    spinnerTargetElement : 'modifyRestrictionsModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                });
                
                //modalBody.load('PatientDetails.do_sec?modifyNwHINOrganizationRestrictions=true', {spinnerTargetElement : 'modifyRestrictionsModalBody'});
            });
            
            //submit modify restrictions
            $('#btnModifyRestrictionsModalSubmit').on('click', function(event){
                //hide the error message
                $('#modifyRestrictionsErrorMessage').hide();
                
                //validate the form
                if ($('#multiSelectListForm').validator('validate').has('.has-error').length || ($('#modifyList1 option').size() < 1) || ($('#modifyList2 option').size() < 1) ) {
                    //we have errors
                    //add has-error and has-danger classes to the form-group surrounding them if the select boxes do not have at least one item in each
                    if($('#modifyList1 option').size() < 1){
                        $('#divList1').addClass('has-error has-danger');
                    }
                    if($('#modifyList2 option').size() < 1){
                        $('#divList2').addClass('has-error has-danger');
                    }
                    
                    $('#modifyRestrictionsErrorMessage').html('Required fields must be completed.');
                    $('#modifyRestrictionsErrorMessage').show();
                } else {
                    //all good!
                    $('#multiSelectListForm').submit();
                    
                    //hide the modal
                    $('#modifyRestrictionsModal').modal('hide');
                }
            });
            
            //revokeRestrictionsModal
            $('#revokeRestrictionsModal').on('show.bs.modal', function(event){
                var modalBody = $(this).find('.modal-body');
                
                $.ajax({
                    url: 'PatientDetails.do_sec?revokeNwHINOrganizationRestrictions=true',
                    spinnerTargetElement : 'revokeRestrictionsModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    modalBody.html(data);
                });
                
                //modalBody.load('PatientDetails.do_sec?revokeNwHINOrganizationRestrictions=true', {spinnerTargetElement : 'revokeRestrictionsModalBody'});
            });
            
            //submit revoke restrictions
            $('#btnRevokeRestrictionsModalSubmit').on('click', function(event){
                //hide the error message
                $('#revokeRestrictionsErrorMessage').hide();
                
                //check to make sure all required fields are good
                updateRevokeRestrictions();
                
                //validate the form
                if ($('#multiSelectListForm2').validator('validate').has('.has-error').length || ($('#revokeList1 option').size() < 1) || ($('#revokeList2 option').size() < 1) ) {
                    //we have errors
                    //add has-error and has-danger classes to the form-group surrounding them if the select boxes do not have at least one item in each
                    if($('#revokeList1 option').size() < 1){
                        $('#divList1').addClass('has-error has-danger');
                    }
                    if($('#revokeList2 option').size() < 1){
                        $('#divList2').addClass('has-error has-danger');
                    }
                    
                    $('#revokeRestrictionsErrorMessage').html('Required fields must be completed.');
                    $('#revokeRestrictionsErrorMessage').show();
                } else {
                    //all good!
                    $('#multiSelectListForm2').submit();
                    
                    //hide the modal
                    $('#revokeRestrictionsModal').modal('hide');
                }
            });
            
            //manageRestrictionsModal
            $('#manageRestrictionsModal').on('show.bs.modal', function(event){
                $.ajax({
                    url: 'PatientDetails.do_sec?authorizeNwHINOrganizationRestrictions=true',
                    spinnerTargetElement : 'manageRestrictionsModalBody',
                    headers: { 'skipLoadingAlert' : 'true' }
                }).done(function(data) {
                    $('#manageRestrictionsModalBody').html(data);
                });
                
                
                //$('#manageRestrictionsModalBody').load('PatientDetails.do_sec?authorizeNwHINOrganizationRestrictions=true', {spinnerTargetElement : 'manageRestrictionsModalBody'});
            });
            
            //submit manage restrictions
            $('#btnManageRestrictionsModalSubmit').on('click', function(event){
                //hide the error message
                $('#manageRestrictionsErrorMessage').hide();
                
                //validate the form
                if ($('#multiSelectListForm').validator('validate').has('.has-error').length || ($('#list1 option').size() < 1) || ($('#list2 option').size() < 1) ) {
                    //we have errors
                    //add has-error and has-danger classes to the form-group surrounding them if the select boxes do not have at least one item in each
                    if($('#list1 option').size() < 1){
                        $('#divList1').addClass('has-error has-danger');
                    }
                    if($('#list2 option').size() < 1){
                        $('#divList2').addClass('has-error has-danger');
                    }
                    
                    $('#manageRestrictionsErrorMessage').html('Required fields must be completed.');
                    $('#manageRestrictionsErrorMessage').show();
                } else {
                    //all good!
                    $('#multiSelectListForm').submit();
                    
                    //hide the modal
                    $('#manageRestrictionsModal').modal('hide');
                }
            });
            //$('#manageRestrictionsModal,#authorizeNwHINModal,#revokeRestrictionsModal,#modifyRestrictionsModal,#cancelDelayedAuthorizationModal,#authorizeDelayNwHINModal,#revokeNwHINModal').on('hidden.bs.modal', function () {
            //nuke everything in any modal on close
            $('.vap-modal-empty-on-close').on('hidden.bs.modal', function () {
                $(this).find('.modal-body').empty();
            });
        });
        
        enableDelayedReasons = function() {
            var button = $('#btnAuthorizeNwHINModalSubmit');
            if ($('#delayedValue').prop('checked')) {
                button.value = "Delay Authorization";
                button.name = "delayAuthorization";
                $('#signatureDate').val('');
            } else {
                button.value = "Authorize";
                button.name = "optIn";
            }
        };
        
        var collectedReasons = [];
        function collectDelayedReasons(reason) {
            if (reason.checked) {
                collectedReasons.push(reason.value);
            } else {
                var index = collectedReasons.indexOf(reason.value);
                collectedReasons.splice(index, 1);
            }
            collectedReasons.sort();
            $('#collectedReasons').val(collectedReasons);
        };
        
        updateRevokeRestrictions = function() {
            //first remove all optional and changeable requiredments on fields
            $('#revokeValidationCheckBoxInput').prop('required', false);
            $('#signatureDate').prop('required', false);
            $('#deceasedDate').prop('required', false);
            
            //clear messaged and highlighting around inputs
            $('#multiSelectListForm2').validator('destroy');
            
            //conditionally add them in based on the inactivation reason
            if($('#reason').val() === 'Patient Deceased') {
                $('#deceasedDate').prop('required', true);
            }
            
            if($('#reason').val() === 'Revoked') {
                $('#revokeValidationCheckBoxInput').prop('required', true);
                $('#signatureDate').prop('required', true);
            }
            
            //update the validator as to what is required
            $('#multiSelectListForm2').validator({
                custom: {
                    isValidDateMMDDYYYY: function($el) { 
                        var today = moment();
                        var dateToValidate = moment($el.val(), 'MM/DD/YYYY');

                        //return true to denote an error
                        return !moment($el.val(), 'MM/DD/YYYY', true).isValid() || dateToValidate.isAfter(today);
                    }
                }
            });
            
            $('#multiSelectListForm2').validator('update');
        };
        
        updateAuthNwHINRequiredFields = function() {
            //first remove all optional and changeable requiredments on fields
            $('#option1').prop('required', false);
            $('#signatureDate').prop('required', false);
            $('#reasonsForDelay1').prop('required', false);
            $('#reasonsForDelay2').prop('required', false);
            $('#reasonsForDelay3').prop('required', false);
            $('#reasonsForDelay4').prop('required', false);
            $('#reasonsForDelay5').prop('required', false);
            $('#reasonsForDelay6').prop('required', false);
            
            //clear messages and highlighting around inputs
            $('#frmAuthorizeNwHIN').validator('destroy');
            
            //conditionally add them in based on the form
            if($('#delayedValue').prop('checked')){
                //we have a delayed auth here so we need to check that at least ONE is checked
                var reasonsForDelay = $("input[name='reasonsForDelay']");
                
                if(reasonsForDelay.filter(':checked').length < 1){
                    $('#reasonsForDelay1').prop('required', true);
                    $('#reasonsForDelay2').prop('required', true);
                    $('#reasonsForDelay3').prop('required', true);
                    $('#reasonsForDelay4').prop('required', true);
                    $('#reasonsForDelay5').prop('required', true);
                    $('#reasonsForDelay6').prop('required', true);
                    
                    $('#authorizeNwHINErrorMessage').html('If an authorization is delayed, at least one reason must be selected.');
                    $('#authorizeNwHINErrorMessage').show();
                }
            } else {
                $('#option1').prop('required', true);
                $('#signatureDate').prop('required', true);
            }
            
            //update the validator as to what is required
            //$('#frmAuthorizeNwHIN').validator('update');
            $('#frmAuthorizeNwHIN').validator({
                custom: {
                    isValidDateMMDDYYYY: function($el) { 
                        var today = moment();
                        var dateToValidate = moment($el.val(), 'MM/DD/YYYY');

                        //return true to denote an error
                        return !moment($el.val(), 'MM/DD/YYYY', true).isValid() || dateToValidate.isAfter(today);
                    }
                }
            });
            $('#frmAuthorizeNwHIN').validator('update');
        };
        
        updateNwHINRequiredFields = function(reason) {
            //first remove all optional and changeable requirements on fields
            $('#signatureDate').prop('required', false);
            $('#revokeValidationCheckBoxInput').prop('required', false);
            $('#deceasedDate').prop('required', false);
            $('#newValidationCheckBoxInput').prop('required', false);
            
            //hide the error message
            $('#revokeNwHINErrorMessage').hide();
            
            //destroy the validator, don't worry we'll update it below. this clears messages and highlighting around inputs
            $('#multiSelectListForm').validator('destroy');
            
            //now conditionally add them in based on the reason selected
            if(reason == 'Patient Deceased') {
                $('#deceasedDate').prop('required', true);
            }
            
            if(reason == 'Revoked') {
                $('#signatureDate').prop('required', true);
                $('#revokeValidationCheckBoxInput').prop('required', true);
            }
            
            if(reason == 'New Authorization') {
                $('#signatureDate').prop('required', true);
                $('#newValidationCheckBoxInput').prop('required', true);
            }
            
            //update the validator as to what is required
            $('#multiSelectListForm').validator('update');
        };
        
        onOptoutReasonChange = function(selectedItem) {
            
            //clear the errors from the Patient Deceased Date and Patient Signature Date
            $('#revokeDateAndUploadValidation').removeClass('has-error has-danger');
            $('#revokeDateAndUploadValidationPatientDeceased').removeClass('has-error has-danger');
            //clear out the dates
            $('#signatureDate').val('');
            $('#deceasedDate').val('');
            
            var consentType = $('#revokeNwHINModal').data("consentType");
            // if selectedItem.value is --Select a reason-- then disable revoke
            // if selectedItem.value is Patient-optedout or --Select a reason-- then disable revoke and enable checkbox
            // if selectedItem.value is anything other than patient-opted-out then enable revoke
            if (selectedItem.value == '') {
                disableObject('Revoke');
                disableObject('revokeValidationCheckBoxInput');
                disableObject('newValidationCheckBoxInput');
                disableObject('signatureDate');
                disableObject('file');
                disableObject('deceasedDate');
                disableObject('revokeAndAuthorize');
                deCheckObject('revokeValidationCheckBoxInput');
                deCheckObject('newValidationCheckBoxInput');
                $('#btnRevokeNwHINModalSubmit').text('Revoke');
                //formHide('revokeAndAuthorizeButton');
                formHide('revokeValidationCheckBox');
                formHide('revokeDateAndUploadValidation');
                formHide('revokeDateAndUploadValidationPatientDeceased');
                formHide('newValidationCheckBox');
                
                //need to update what fields are required and the validator
                updateNwHINRequiredFields(selectedItem.value);
            } else if (selectedItem.value == 'Revoked') {
                disableObject('Revoke');
                enableObject('revokeValidationCheckBoxInput');
                disableObject('newValidationCheckBoxInput');
                enableObject('signatureDate');
                disableObject('file');
                disableObject('deceasedDate');
                disableObject('revokeAndAuthorize');
                deCheckObject('revokeValidationCheckBoxInput');
                deCheckObject('newValidationCheckBoxInput');
                //formShow('revokeButton');
                if(consentType !== 'wft') {
                    $('#btnRevokeNwHINModalSubmit').text('Revoke');
                }
                //formHide('revokeAndAuthorizeButton');
                formShow('revokeValidationCheckBox');
                formShow('revokeDateAndUploadValidation');
                formHide('revokeDateAndUploadValidationPatientDeceased');
                formHide('newValidationCheckBox');
                enableRevokeAfterValidation('signatureDate', 'Revoke');
                
                //need to update what fields are required and the validator
                updateNwHINRequiredFields(selectedItem.value);
            } else if (selectedItem.value == 'Patient Deceased') {
                disableObject('Revoke');
                disableObject('revokeValidationCheckBoxInput');
                disableObject('newValidationCheckBoxInput');
                disableObject('signatureDate');
                disableObject('file');
                enableObject('deceasedDate');
                disableObject('revokeAndAuthorize');
                deCheckObject('revokeValidationCheckBoxInput');
                deCheckObject('newValidationCheckBoxInput');
                //formShow('revokeButton');
                if(consentType !== 'wft') {
                    $('#btnRevokeNwHINModalSubmit').text('Revoke');
                }
                //formHide('revokeAndAuthorizeButton');
                formHide('revokeValidationCheckBox');
                formHide('revokeDateAndUploadValidation');
                formShow('revokeDateAndUploadValidationPatientDeceased');
                formHide('newValidationCheckBox');
                enableRevokeAfterValidation('deceasedDate', 'Revoke');
                
                //need to update what fields are required and the validator
                updateNwHINRequiredFields(selectedItem.value);
            } else if (selectedItem.value == 'New Authorization') {
                disableObject('Revoke');
                disableObject('revokeValidationCheckBoxInput');
                enableObject('newValidationCheckBoxInput');
                enableObject('signatureDate');
                disableObject('file');
                disableObject('deceasedDate');
                disableObject('revokeAndAuthorize');
                //formShow('revokeAndAuthorizeButton');
                if(consentType !== 'wft') {
                    $('#btnRevokeNwHINModalSubmit').text('Revoke and Submit New Authorization');
                }
                deCheckObject('revokeValidationCheckBoxInput');
                deCheckObject('newValidationCheckBoxInput');
                disableObject('revokeAndAuthorize');
                //formHide('revokeButton');
                formHide('revokeValidationCheckBox');
                formShow('revokeDateAndUploadValidation');
                formHide('revokeDateAndUploadValidationPatientDeceased');
                formShow('newValidationCheckBox');
                enableRevokeAfterValidation('signatureDate', 'Revoke');
                
                //need to update what fields are required and the validator
                updateNwHINRequiredFields(selectedItem.value);
            } else {
                enableObject('Revoke');
                disableObject('revokeValidationCheckBoxInput');
                disableObject('newValidationCheckBoxInput');
                disableObject('signatureDate');
                disableObject('file');
                disableObject('deceasedDate');
                disableObject('revokeAndAuthorize');
                deCheckObject('revokeValidationCheckBox');
                deCheckObject('newValidationCheckBox');
                //formShow('revokeButton');
                //formHide('revokeAndAuthorizeButton');
                if(consentType !== 'wft') {
                    $('#btnRevokeNwHINModalSubmit').text('Revoke');
                }
                formHide('revokeValidationCheckBox');
                formHide('revokeDateAndUploadValidation');
                formHide('revokeDateAndUploadValidationPatientDeceased');
                formHide('newValidationCheckBox');
                
                //need to update what fields are required and the validator
                updateNwHINRequiredFields(selectedItem.value);
            }
        };
        
        formShow = function(id) {
            var elmt = document.getElementById(id);
            if (elmt != null) {
                elmt.style.display = "block";
            }
        };
        
        formHide = function(id) {
            var elmt = document.getElementById(id);
            if (elmt != null) {
                elmt.style.display = "none";
            }
        };
        
        enableObjectByCheck = function(obj, arg) {
            var elmt = document.getElementById(arg);
            if (elmt != null) {
                if (obj.checked == true) {
                    elmt.disabled = false;
                } else {
                    elmt.disabled = true;
                }
            }
        };
        
        deCheckObject = function(obj) {
            var elmt = document.getElementById(obj);
            if (elmt != null) {
                elmt.checked = false;
            }
        };

        enableObject = function(arg) {
            var elmt = document.getElementById(arg);
            if (elmt != null) {
                elmt.disabled = false;
            }
        };
        
        disableObject = function(arg) {
            var elmt = document.getElementById(arg);
            if (elmt != null) {
                elmt.disabled = true;
            }
        };
        
        enableRevokeAfterValidation = function(objA, arg) {
            var valelmentA = document.getElementById(objA);
            var elmt = document.getElementById(arg);
            if (elmt != null) {
                var elmtOptionA = document.getElementById('revokeValidationCheckBox');
                var elmtOptionB = document.getElementById('newValidationCheckBox');
                if ((elmtOptionA != null && elmtOptionA.style.display != "none") || (elmtOptionB != null && elmtOptionB.style.display != "none")) {
                    if (elmtOptionA != null && elmtOptionA.style.display != "none") {
                        var valelmentB = document.getElementById('revokeValidationCheckBoxInput');
                    } else {
                        var valelmentB = document.getElementById('newValidationCheckBoxInput');
                        var elmt = document.getElementById('revokeAndAuthorize');
                    }
                    if (valelmentA.value != '' && isDate(valelmentA.value) == true && valelmentB.checked == true) {
                        elmt.disabled = false;
                    } else {
                        elmt.disabled = true;
                    }
                } else {
                    if (valelmentA.value != '' && isDate(valelmentA.value) == true) {
                        elmt.disabled = false;
                    } else {
                        elmt.disabled = true;
                    }
                }
            }
        };
    </script>
    <div class="row pad-bottom-20">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" role="navigation">
            <ul class="nav nav-tabs">
                <li role="presentation" class="active"><a href="#" aria-label="Patient Summary tab, active">Patient Summary</a></li>
                <li role="presentation"><a href="PatientDetails.do_sec?view=true" aria-label="Health Summary (C32) tab, inactive">Health Summary (C32)</a></li>
                <li role="presentation"><a href="PatientDetails.do_sec?viewCCDA=true" aria-label="Health Summary (C-CDA) tab, inactive">Health Summary (C-CDA)</a></li>
            </ul>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
            <%-- patient information --%>
             <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        Patient Information
                    </div>
                </div>    
                 <div class="panel-body">
                    <div class="row">
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Patient</strong><br />
                           <c:out value="${patientDemographics.prefix}" /> <c:out value="${patientDemographics.firstName}" /> <c:out value="${patientDemographics.middleName}" /> <c:out value="${patientDemographics.lastName}" /> <c:out value="${patientDemographics.suffix}" />
                        </div>
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Marital Status</strong><br />
                            <c:choose>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'M')==true}">Married </c:when>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'S')==true}">Single </c:when>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'D')==true}">Divorced </c:when>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'W')==true}">Widowed </c:when>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'P')==true}">Separated </c:when>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'C')==true}">Correction </c:when>
                               <c:when test="${fn:containsIgnoreCase(patientDemographics.maritalStatus, 'DP')==true}">Domestic Partner </c:when>
                               <c:otherwise><c:out value="${patientDemographics.maritalStatus}" /> </c:otherwise>
                           </c:choose>
                        </div>
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>ICN</strong><br />
                            <c:out value="${patientDemographics.icn}" />
                        </div>
                    </div>
                    <div class="row pad-top-20">
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Gender</strong><br />
                            <c:choose>
                                <c:when test="${fn:containsIgnoreCase(patientDemographics.gender, 'M')==true}"> Male </c:when>
                                <c:when test="${fn:containsIgnoreCase(patientDemographics.gender, 'F')==true}"> Female </c:when>
                                <c:otherwise> <c:out value="${patientDemographics.gender}" /> </c:otherwise>
                            </c:choose>
                        </div>
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Multiple Birth</strong><br />
                            <c:choose>
                                <c:when test="${fn:containsIgnoreCase(patientDemographics.multipleBirthIndicator, 'N')==true}"> NO </c:when>
                                <c:when test="${fn:containsIgnoreCase(patientDemographics.multipleBirthIndicator, 'Y')==true}"> YES </c:when>
                                <c:otherwise> <c:out value="${patientDemographics.multipleBirthIndicator}" /> </c:otherwise>
                            </c:choose>
                        </div>
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Address</strong><br />
                            <address>
                                <c:if test="${!empty patientDemographics.streetAddressLine1}"> <c:out value="${patientDemographics.streetAddressLine1}" /><br /></c:if> 
                                <c:if test="${!empty patientDemographics.streetAddressLine2}"> <c:out value="${patientDemographics.streetAddressLine2}" /><br /></c:if> 
                                <c:if test="${!empty patientDemographics.streetAddressLine3}"> <c:out value="${patientDemographics.streetAddressLine3}" /><br /></c:if> 
                                <c:out value="${patientDemographics.residenceCity}" />, <c:out value="${patientDemographics.residenceState}" />&nbsp;&nbsp;<c:out value="${patientDemographics.residenceZip4}" />
                            </address>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Date of Birth</strong><br />
                            <fmt:formatDate pattern="MM/dd/yyyy" value="${patientDemographics.dob}" />
                        </div>
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>SSN</strong><br />
                            <c:out value="${patientDemographics.ssn}" />
                        </div>
                        <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                            <strong>Phone</strong><br />
                            <c:out value="${patientDemographics.residencePhoneNumber}" />
                        </div>
                    </div>
                 </div>
             </div>
            
            <%-- announce --%>
             <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        Announce
                    </div>
                </div>    
                 <div class="panel-body">
                     <div class="alert alert-info">
                        The <c:if test="${hasBeenAnnounced}">Re-</c:if>Announce Button action Broadcasts this patient's demographics to
                        <c:out value="${organizationName}" /> participants to attempt to create correlations and subsequently share information with other
                        participating partners at which the patient is known. <u>DoD patients are announced but are not opted-in.</u>
                     </div>
                    <div>
                        <form action="PatientDetails.do_sec" method="POST">
                            <input type="hidden" name="icn" title="icn" value="<c:out value="${patientDemographics.icn}" />" /> <input type="hidden" name="requestId" title="requestId" value="<c:out value="${requestId}" />" />
                            <div>
                                <strong><c:if test="${hasBeenAnnounced}">Re-</c:if>Announce</strong>
                            </div>
                            <div>
                                Broadcast this patient's demographics to <c:out value="${organizationName}" /> to create correlations in the VA's Master Patient Index to other providers at which the patient is known.
                            </div>
                            <div class="text-right">						
                                <input title="Announce patient to <c:out value="${organizationName}" /> partners" class="btn btn-primary" type="submit" name="announce" id="announceButton" value="<c:if test="${hasBeenAnnounced}">Re-</c:if>Announce" />
                            </div>
                            <c:if test="${not empty  lastAnnouncement}">
                                <div class="pad-top-10">
                                    <strong><c:out value="${lastAnnouncement}" /> CT</strong>
                                </div>
                            </c:if>
                        </form>
                    </div>
                 </div>
             </div>        
        </div>
        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
            <%-- comments --%>
             <div class="panel panel-default" id="divCommentsPanel">
                <div class="panel-heading">
                    <div class="panel-title">
                        <div class="pull-left">
                            <a href="#" title="Comments" aria-label="Comments" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="commentsPanel"></i></a> Comments
                        </div>
                        <div class="pull-right">
                            <a href="#" title="Add Comment" data-toggle="modal" data-target="#patientCommentModal" aria-label="Add Comment"><i class="fa fa-plus" aria-hidden="true"></i></a> Add Comment
                        </div>
                        <div class="clearfix"></div>
                    </div>
                </div>    
                <div class="panel-body" id="commentsPanel">
                    <div id="patientCommentMessage" class="alert alert-success pad-bottom-10 pad-top-10 pad-left-10" style="display: none;" role="alert">
                        Comment added successfully.
                    </div>
                    <table id="tblComments" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                        <thead>
                            <tr role="row">
                                <th role="columnheader" width="180" class="text-center">Date</th>
                                <th role="columnheader" width="150" class="text-center">User</th>
                                <th role="columnheader" class="text-center">Comments</th>
                            </tr>
                        </thead>
                    </table>
                </div>
             </div>
        </div>
        <%-- DIV for Patient bulk download --%>
        <cpp:userInRole role="VAPApplicationReportsUser">
            <div class="col-xs-6">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="panel-title">Data Quality Export</div>
                    </div>    
                    <div class="panel-body">
                        <div>This feature will allow you to download all documents for the patient that are referenced by an eHealth Exchange Adapter Audit.</div>
                        <div class="text-right pad-top-10">
                            <a href="AdapterDateRangeReport.do_sec?startDate=${reportStartDate}&endDate=${reportEndDate}&patientIdentifier=<c:out value="${patientDemographics.icn}"/>" title="Download Audited Patient Documents" class="btn btn-primary">
                                Download Audited Patient Documents
                            </a>
                        </div>
                    </div>
                </div>  
            </div>
        </cpp:userInRole>
    </div>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <%-- manage access --%>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        Manage Access to Veteran Health Records
                    </div>
                </div>
                <div class="panel-body">
                    <c:set var="NwHINactiveDelay" value="${NwHINactiveDelay}" />
                    <c:set var="wftActiveDelay" value="${wftActiveDelay}" />
                    <c:set var="SSAactiveDelay" value="${SSAactiveDelay}" />

                    <c:set var="ehxHdrColStyle" value="${enableShareNormalWithoutConsentModel ? 'col-xs-9' : 'col-xs-8'}" />
                    <c:set var="ssaHdrColStyle" value="${enableShareNormalWithoutConsentModel ? 'col-xs-3' : 'col-xs-4'}" />
                    <c:set var="consentDtlsColStyle" value="${enableShareNormalWithoutConsentModel ? 'col-xs-3' : 'col-xs-4'}" />

                    <div class="row">
                        <!-- access -->
                        <div class="col-xs-4 vap-min-height-220">
                            <h4><c:out value="${organizationName}"/> Access</h4>
                            <h4 class="text-success pad-top-10"><i class="fa fa-check-circle-o" aria-hidden="true"></i>
                                ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Conditions' : 'Access'}
                            </h4>
                            <c:set var="vetEHIWithOrgName" value="Veteran electronic health information (${organizationName})"/>
                            <c:choose>
                                <c:when test="${!empty consentDirective}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently authorized the release </strong>
                                            of ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : 'protected'}
                                            health information from <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${consentDirective.optinDate}" /></strong>
                                            through <c:out value="${organizationName}"/>.
                                        </p>
                                        <p>
                                            <c:out value="${isNewAuthorizationAllowed ? 'Revoke access or submit new authorization' : 'Revoke access'}"/>
                                            for the release of ${enableShareNormalWithoutConsentModel ?
                                                '38 USC &#xa7; 7332 Protected health records' :
                                                vetEHIWithOrgName}
                                            to non-VA healthcare provider organizations via <c:out value="${organizationName}"/> 
                                            for the purposes of treatment.
                                        </p>
                                    </div>
                                    <div class="bottom-zero-absolute-right-10">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#revokeNwHINModal" data-consent-type="nwhin7332">
                                            Revoke ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : organizationName}
                                        </button>
                                    </div>
                                </c:when>
                                <c:when test="${NwHINactiveDelay != null}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has an authorization to release </strong>
                                            ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : 'protected'}
                                            health information through <c:out value="${organizationName}"/> in
                                            <strong>DELAYED</strong> status, pending final approval.
                                            Reason<c:if test="${fn:length(NwHINactiveDelay.delayReasonCollection) > 1}">s</c:if> for delay:
                                            <c:forEach var="r" items="${NwHINactiveDelay.delayReasonCollection}" varStatus="loop">
                                                <c:out value="${r.name}"/><c:if test="${fn:length(NwHINactiveDelay.delayReasonCollection) gt 1 and (loop.index lt fn:length(NwHINactiveDelay.delayReasonCollection) - 1)}">,</c:if>
                                            </c:forEach>
                                        </p>
                                    </div>
                                    <div class="bottom-zero-absolute-right-10t">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#authorizeDelayNwHINModal" data-delayed-consent-id="<c:out value="${NwHINactiveDelay.delayedConsentId}"/>" data-consent-type="nwhin7332">Approve Authorization</button>
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#cancelDelayedAuthorizationModal" data-delayed-consent-id="<c:out value="${NwHINactiveDelay.delayedConsentId}"/>" data-consent-type="nwhin7332">Cancel Authorization</button>
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#printLetterModal" data-delayed-consent-id="<c:out value="${NwHINactiveDelay.delayedConsentId}"/>" data-consent-type="nwhin7332">Print Notification Letter</button>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently NOT authorized the release</strong>
                                            of ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : 'protected'}
                                            health information through <c:out value="${organizationName}"/>.
                                        </p>
                                        <p>
                                            Share ${enableShareNormalWithoutConsentModel ?
                                                '38 USC &#xa7; 7332 Protected health records' :
                                                vetEHIWithOrgName}
                                            with non-VA healthcare provider organizations via <c:out value="${organizationName}"/> for the purposes of treatment.
                                        </p>
                                    </div>
                                    <div class="bottom-zero-absolute-right-10">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#authorizeNwHINModal" data-consent-type="nwhin7332">
                                            Authorize ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : organizationName}
                                        </button>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                        <!-- restrictions -->
                        <div class="col-xs-4 vap-min-height-220">
                            <div class="h4">&nbsp;</div>
                            <h4 class="text-danger pad-top-10"><i class="fa fa-ban" aria-hidden="true"></i> Restrictions</h4>
                            <c:if test="${isOrganizationExclusionsAllowed}">
                                <c:choose>
                                    <c:when test="${!empty nwhinOrganizationRestrictionsDirective}">
                                        <div>
                                            <p>
                                                <strong>The Veteran currently has Restrictions </strong> that limit the sharing of electronic health information.
                                            </p>
                                            <p>
                                                View/Modify, revoke, or terminate Veteran's existing restrictions that limit the sharing of electronic health information.
                                            </p>
                                        </div>
                                        <div class="bottom-zero-absolute-right-10">
                                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modifyRestrictionsModal">View/Modify Restrictions</button>
                                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#revokeRestrictionsModal">Revoke Restrictions</button>
                                        </div>
                                    </c:when>
                                    <c:otherwise>
                                        <div>
                                            <p>
                                                <strong>The Veteran has currently no restrictions.</strong>
                                            </p>
                                            <p>
                                                Manage Veteran restrictions that limit the sharing of his/her electronic health information for 
                                                non-VA healthcare provider organizations via <c:out value="${organizationName}"/> for the purpose of treatment.
                                            </p>
                                        </div>
                                            <div class="bottom-zero-absolute-right-10">
                                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#manageRestrictionsModal">Manage Restrictions</button>
                                        </div>
                                    </c:otherwise>
                                </c:choose>
                            </c:if>
                        </div>
                        <!-- SSA -->
                        <div class="col-xs-4 left-border vap-min-height-220">
                            <h4>Social Security Administration (SSA)</h4>
                            <h4 class="text-success pad-top-10"><i class="fa fa-check-circle-o" aria-hidden="true"></i> Access</h4>
                            <c:choose>
                                <c:when test="${!empty ssaConsentDirective}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently authorized the release of </strong> protected health information to the Social Security Administration from
                                            <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${ssaConsentDirective.optinDate}" /> </strong> that expires on
                                            <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${ssaConsentDirective.expirationDate}" />, </strong> through <c:out value="${organizationName}"/>.
                                        </p>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently NOT authorized the release of </strong>
                                            protected health information to the Social Security Administration through <c:out value="${organizationName}"/>.
                                        </p>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                    </div>
                </div>
                <%-- <div class="panel-body">
                    <c:set var="NwHINactiveDelay" value="${NwHINactiveDelay}" />
                    <c:set var="wftActiveDelay" value="${wftActiveDelay}" />
                    <c:set var="SSAactiveDelay" value="${SSAactiveDelay}" />

                    <c:set var="ehxHdrColStyle" value="${enableShareNormalWithoutConsentModel ? 'col-xs-9' : 'col-xs-8'}" />
                    <c:set var="ssaHdrColStyle" value="${enableShareNormalWithoutConsentModel ? 'col-xs-3' : 'col-xs-4'}" />
                    <c:set var="consentDtlsColStyle" value="${enableShareNormalWithoutConsentModel ? 'col-xs-3' : 'col-xs-4'}" />
                    <!-- Bootstrap Grid scales up, so if col-xs-N, col-sm-N, etc. all have
                         same N cols, only the smallest one needs to be there.
                         Doubtful the XS settings we have would actually look right on phone.
                    -->
                    <div class="row">
                        <div class="${ehxHdrColStyle}">
                            <h4><c:out value="${organizationName}"/> Access</h4>
                        </div>
                        <div class="${ssaHdrColStyle} left-border">
                            <h4>Social Security Administration (SSA)</h4>
                        </div>
                    </div>
                            
                    <div class="row">
                        <c:if test="${enableShareNormalWithoutConsentModel}">
                        <!-- Following div is description of state for Withhold for Treatment directive. -->
                        <div class="${consentDtlsColStyle}">
                            <h4 class="text-success"><i class="fa fa-ban" aria-hidden="true"></i> Opt-Out</h4>
                            <c:choose>
                                <c:when test="${!empty wftConsentDirective}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently requested to opt-out (withhold the release of protected health information)</strong>
                                            beginning on <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${wftConsentDirective.optinDate}" /></strong>
                                            from <c:out value="${organizationName}"/> for the purposes of treatment.
                                        </p>
                                        <p>
                                            Rescind opt-out (rescind withholding the release of protected health information)
                                            from <c:out value="${organizationName}"/> for the purposes of treatment.
                                        </p>
                                    </div>
                                </c:when>
                                <c:when test="${wftActiveDelay != null}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has a request to opt-out (withhold the release of protected health information)</strong>
                                            from <c:out value="${organizationName}"/> in
                                            <strong>DELAYED</strong> status, pending final approval.
                                            Reason<c:if test="${fn:length(wftActiveDelay.delayReasonCollection) > 1}">s</c:if> for delay:
                                            <c:forEach var="r" items="${wftActiveDelay.delayReasonCollection}" varStatus="loop">
                                                <c:out value="${r.name}"/><c:if test="${fn:length(wftActiveDelay.delayReasonCollection) gt 1 and (loop.index lt fn:length(wftActiveDelay.delayReasonCollection) - 1)}">,</c:if>
                                            </c:forEach>
                                        </p>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently NOT requested to opt-out (withhold the release
                                            of protected health information)</strong> from <c:out value="${organizationName}"/>. 
                                            The Veteran's protected health information may be released through <c:out value="${organizationName}"/>,
                                            subject to the authorization requirements on 38 USC &#xa7; 7332 Protected Conditions.
                                        </p>
                                        <p>
                                            Withhold sharing of Veteran electronic health information (<c:out value="${organizationName}"/>)
                                            with non-VA healthcare provider organizations via <c:out value="${organizationName}"/> for the purposes of treatment.
                                        </p>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                    </c:if>

                        <!-- Following div is description of state for NwHIN Authorization directive. -->
                        <div class="${consentDtlsColStyle}">
                            <h4 class="text-success"><i class="fa fa-check-circle-o" aria-hidden="true"></i>
                                ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Conditions' : 'Access'}
                            </h4>
                            <c:set var="vetEHIWithOrgName" value="Veteran electronic health information (${organizationName})"/>
                            <c:choose>
                                <c:when test="${!empty consentDirective}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently authorized the release </strong>
                                            of ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : 'protected'}
                                            health information from <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${consentDirective.optinDate}" /></strong>
                                            through <c:out value="${organizationName}"/>.
                                        </p>
                                        <p>
                                            <c:out value="${isNewAuthorizationAllowed ? 'Revoke access or submit new authorization' : 'Revoke access'}"/>
                                            for the release of ${enableShareNormalWithoutConsentModel ?
                                                '38 USC &#xa7; 7332 Protected health records' :
                                                vetEHIWithOrgName}
                                            to non-VA healthcare provider organizations via <c:out value="${organizationName}"/> 
                                            for the purposes of treatment.
                                        </p>
                                    </div>
                                </c:when>
                                <c:when test="${NwHINactiveDelay != null}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has an authorization to release </strong>
                                            ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : 'protected'}
                                            health information through <c:out value="${organizationName}"/> in
                                            <strong>DELAYED</strong> status, pending final approval.
                                            Reason<c:if test="${fn:length(NwHINactiveDelay.delayReasonCollection) > 1}">s</c:if> for delay:
                                            <c:forEach var="r" items="${NwHINactiveDelay.delayReasonCollection}" varStatus="loop">
                                                <c:out value="${r.name}"/><c:if test="${fn:length(NwHINactiveDelay.delayReasonCollection) gt 1 and (loop.index lt fn:length(NwHINactiveDelay.delayReasonCollection) - 1)}">,</c:if>
                                            </c:forEach>
                                        </p>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently NOT authorized the release</strong>
                                            of ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : 'protected'}
                                            health information through <c:out value="${organizationName}"/>.
                                        </p>
                                        <p>
                                            Share ${enableShareNormalWithoutConsentModel ?
                                                '38 USC &#xa7; 7332 Protected health records' :
                                                vetEHIWithOrgName}
                                            with non-VA healthcare provider organizations via <c:out value="${organizationName}"/> for the purposes of treatment.
                                        </p>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                        <div class="${consentDtlsColStyle}">
                            <h4 class="text-danger"><i class="fa fa-ban" aria-hidden="true"></i> Restrictions</h4>
                            <c:if test="${isOrganizationExclusionsAllowed}">
                                <c:choose>
                                    <c:when test="${!empty nwhinOrganizationRestrictionsDirective}">
                                        <div>
                                            <p>
                                                <strong>The Veteran currently has Restrictions </strong> that limit the sharing of electronic health information.
                                            </p>
                                            <p>
                                                View/Modify, revoke, or terminate Veteran's existing restrictions that limit the sharing of electronic health information.
                                            </p>
                                        </div>
                                    </c:when>
                                    <c:otherwise>
                                        <div>
                                            <p>
                                                <strong>The Veteran has currently no restrictions.</strong>
                                            </p>
                                            <p>
                                                Manage Veteran restrictions that limit the sharing of his/her electronic health information for 
                                                non-VA healthcare provider organizations via <c:out value="${organizationName}"/> for the purpose of treatment.
                                            </p>
                                        </div>
                                    </c:otherwise>
                                </c:choose>
                            </c:if>
                        </div>
                        <div class="${consentDtlsColStyle} left-border vap-min-height-180"> <!-- SSA -->
                            <h4 class="text-success"><i class="fa fa-check-circle-o" aria-hidden="true"></i> Access</h4>
                            <c:choose>
                                <c:when test="${!empty ssaConsentDirective}">
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently authorized the release of </strong> protected health information to the Social Security Administration from
                                            <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${ssaConsentDirective.optinDate}" /> </strong> that expires on
                                            <strong><fmt:formatDate pattern="MM/dd/yyyy" value="${ssaConsentDirective.expirationDate}" />, </strong> through <c:out value="${organizationName}"/>.
                                        </p>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div>
                                        <p>
                                            <strong>The Veteran has currently NOT authorized the release of </strong>
                                            protected health information to the Social Security Administration through <c:out value="${organizationName}"/>.
                                        </p>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                    </div>

                    <!-- buttons for the manage access/restrictions, yup, same logic as above but here for the buttons themselves --> 
                    <div class="row">
                      <c:if test="${enableShareNormalWithoutConsentModel}">                        
                        <div class="${consentDtlsColStyle}">
                            <c:choose>
                                <c:when test="${!empty wftConsentDirective}">
                                    <div class="text-right">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#revokeNwHINModal" data-consent-type="wft" data-title="Rescind Opt-Out">Rescind Opt-Out Request</button>
                                    </div>
                                </c:when>
                                <c:when test="${wftActiveDelay != null}">
                                    <div class="text-right">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#authorizeDelayNwHINModal" data-delayed-consent-id="<c:out value="${wftActiveDelay.delayedConsentId}"/>" data-consent-type="wft" data-title="Opt-Out">Approve Request</button>
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#cancelDelayedAuthorizationModal" data-delayed-consent-id="<c:out value="${wftActiveDelay.delayedConsentId}"/>" data-consent-type="wft" data-title="Cancel Opt-Out">Cancel Request</button>
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#printLetterModal" data-delayed-consent-id="<c:out value="${wftActiveDelay.delayedConsentId}"/>" data-consent-type="wft">Print Notification Letter</button>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div class="text-right">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#authorizeNwHINModal" data-consent-type="wft" data-title="Opt-Out">Request Opt-Out</button>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                      </c:if>
                        <div class="${consentDtlsColStyle}">
                            <c:choose>
                                <c:when test="${!empty consentDirective}">
                                    <div class="text-right">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#revokeNwHINModal" data-consent-type="nwhin7332">
                                            Revoke ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : organizationName}
                                        </button>
                                    </div>
                                </c:when>
                                <c:when test="${NwHINactiveDelay != null}">
                                    <div class="text-right">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#authorizeDelayNwHINModal" data-delayed-consent-id="<c:out value="${NwHINactiveDelay.delayedConsentId}"/>" data-consent-type="nwhin7332">Approve Authorization</button>
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#cancelDelayedAuthorizationModal" data-delayed-consent-id="<c:out value="${NwHINactiveDelay.delayedConsentId}"/>" data-consent-type="nwhin7332">Cancel Authorization</button>
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#printLetterModal" data-delayed-consent-id="<c:out value="${NwHINactiveDelay.delayedConsentId}"/>" data-consent-type="nwhin7332">Print Notification Letter</button>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <div class="text-right">
                                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#authorizeNwHINModal" data-consent-type="nwhin7332">
                                            Authorize ${enableShareNormalWithoutConsentModel ? '38 USC &#xa7; 7332 Protected' : organizationName}
                                        </button>
                                    </div>
                                </c:otherwise>
                            </c:choose>
                        </div>
                        <div class="${consentDtlsColStyle}">
                            <c:if test="${isOrganizationExclusionsAllowed}">
                                <c:choose>
                                    <c:when test="${!empty nwhinOrganizationRestrictionsDirective}">
                                        <div class="text-right">
                                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modifyRestrictionsModal">View/Modify Restrictions</button>
                                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#revokeRestrictionsModal">Revoke Restrictions</button>
                                        </div>
                                    </c:when>
                                    <c:otherwise>
                                        <div class="text-right">
                                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#manageRestrictionsModal">Manage Restrictions</button>
                                        </div>
                                    </c:otherwise>
                                </c:choose>
                            </c:if>
                        </div>
                        <div class="${consentDtlsColStyle} left-border vap-min-height-25">
                            <!-- No action can be taken on SSA auths from this UI. -->
                        </div>
                    </div>
                </div>--%>
            </div>     
        </div>
    </div>
    <div class="row" id="divStatusHistory">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <%-- status history --%>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#divStatusHistory" title="Status History" aria-label="Status History" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="statusHistoryPanel"></i></a> Status History
                    </div>
                </div>    
                 <div class="panel-body" id="statusHistoryPanel">
                     <%-- TODO: rework this to have one div and set the html before popping it --%>
                     <div id="printLetterMessage" class="alert alert-success" style="display: none;" role="alert">
                         Letter successfully generated
                     </div>
                     <div id="mailDatesMessage" class="alert alert-success" style="display: none;" role="alert">
                         Mail dates successfully updated
                     </div>
                     <div id="consentCommentMessage" class="alert alert-success" style="display: none;" role="alert">
                         Comment successfully added
                     </div>
                     <%@include file="consentHistory.jsp"%>
                 </div>
             </div>
        </div>
    </div>
    <div class="row" id="divCorrelations">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <%-- eHealth exchange correlations --%>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#divCorrelations" title="Correlations" aria-label="Correlations" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="correlationsPanel"></i></a> <c:out value="${organizationName}" /> Correlations
                    </div>
                </div>    
                 <div class="panel-body" id="correlationsPanel">
                     <table id="tblCorrelations" class="table table-striped">
                        <thead>
                            <tr role="row">
                                <th role="columnheader" class="text-center">Facility Number</th>
                                <th role="columnheader" class="text-center"><c:out value="${organizationName}" /> Organization Name</th>
                                <th role="columnheader" class="text-center"><c:out value="${organizationName}" /> Organization Assigning Authority</th>
                                <th role="columnheader" class="text-center">Patient ID</th>
                            </tr>
                        </thead>
                        <tbody>
                            <c:forEach var="r" items="${correlations}" varStatus="i">
                                <tr role="row">
                                    <td role="gridcell"><c:out value="${r.facilityNumber}" /></td>
                                    <td role="gridcell" title="<c:out value="${r.organizationOid}" />"><c:out value="${r.facilityName}" /></td>
                                        <c:choose>
                                            <c:when test="${empty r.assigningAuthorityName}">
                                                <td title="<c:out value="${r.assigningAuthorityOid}" />"><c:out value="${r.assigningAuthorityOid}" /></td>
                                            </c:when>
                                            <c:otherwise>
                                                <td title="<c:out value="${r.assigningAuthorityOid}" />"><c:out value="${r.assigningAuthorityName}" /></td>
                                            </c:otherwise>
                                        </c:choose>
                                    <td role="gridcell"><c:out value="${r.correlatedPatientId}" /></td>
                                </tr>
                            </c:forEach>
                            <%-- <c:if test="${empty correlations}">
                                <tr role="row">
                                    <td role="gridcell" colspan="4" class="text-center">This patient has no <c:out value="${organizationName}" /> correlations.</td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell"></td>
                                </tr>
                            </c:if> --%>
                        </tbody>
                    </table>

                    <c:choose>
                        <c:when test="${!empty correlations}">
                            <div class="alert alert-info margin-top-10">
                                If a correlation needs to be removed,
                                please contact your local MPI Point of Contact who will work with
                                the national Healthcare Identity Management (HC IdM) Team to
                                complete that action.
                            </div>
                            <cpp:userInRole role="VAPApplicationTester">
                                <div class="alert alert-warning margin-top-10">
                                    The Remove Correlation action should only be taken with
                                    Supervisory approval and is only used in rare circumstances (such
                                    as when a patient has been correlated with an incorrect record at
                                    a participating partner). NOTE: The Remove Correlation action
                                    will remove <strong>all</strong> patient correlations other than DoD.
                                </div>
                                <div>
                                    <form action="PatientDetails.do_sec" method="POST">
                                        <div class="pull-left">Remove correlations to <c:out value="${organizationName}" /> partners from VA's Master Patient Index.</div>
                                        <div class="pull-right">
                                            <input title="Remove Correlations" class="btn btn-primary" type="submit" name="revoke" value="Remove Correlations" <c:if test="${empty correlations}">disabled="disabled"</c:if> onclick="revokeClicked = true" />
                                        </div>
                                        <div class="clearfix"></div>
                                    </form>
                                </div>
                            </cpp:userInRole>
                        </c:when>
                    </c:choose>
                 </div>
             </div>
        </div>
    </div>
    
    <%-- modals for use on the patient details page --%>
    <div class="modal fade" id="patientCommentModal" role="dialog" data-backdrop="static" aria-labelledby="patientCommentModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="patientCommentModalLabel">Add Comment</h4>
                    </div>
                    <div class="modal-body">
                        <div id="patientCommentError" class="alert alert-danger" style="display: none;" role="alert">
                            Comments are required.
                        </div>
                        <form name="patientCommentForm" id="patientCommentForm" class="form-horizontal" role="form" data-toggle="validator">
                            <input type="hidden" name="patientIen" id="patientIen" value="<c:out value="${patientDemographics.icn}" />" />
                            <div class="form-group">
                                <label for="patientComments" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Comment is a required field." labelText="Comment" /></label>
                                <div class="col-xs-10 col-sm-10 col-md-10 col-lg-10">
                                    <textarea id="patientComments" name="patientComments" class="form-control" rows="5" required></textarea>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="btnPatientCommentClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnPatientCommentSubmit" class="btn btn-primary">Save</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="printLetterModal" role="dialog" data-backdrop="static" aria-labelledby="printLetterModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="printLetterModalLabel">Generate Notification Letter</h4>
                    </div>
                    <div class="modal-body" id="printLetterModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnPrintLetterClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnPrintLetterSubmit" class="btn btn-primary">Generate</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="mailDateModal" role="dialog" data-backdrop="static" aria-labelledby="mailDateModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="mailDateModalLabel">Edit Mail Notification Dates</h4>
                    </div>
                    <div class="modal-body" id="mailDateModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnMailDateClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnMailDateSubmit" class="btn btn-primary" data-mail-date-div="">Save</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="consentCommentModal" role="dialog" data-backdrop="static" aria-labelledby="consentCommentModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="consentCommentModalLabel">Add Comment</h4>
                    </div>
                    <div class="modal-body" id="consentCommentModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnConsentCommentClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnConsentCommentSubmit" class="btn btn-primary" data-consent-comment-div="">Save</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="revokeNwHINModal" role="dialog" data-backdrop="static" aria-labelledby="revokeNwHINModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="revokeNwHINModalLabel">Revoke</h4>
                    </div>
                    <div class="modal-body" id="revokeNwHINModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnRevokeNwHINModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnRevokeNwHINModalSubmit" class="btn btn-primary">Revoke</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="authorizeNwHINModal" role="dialog" data-backdrop="static" aria-labelledby="authorizeNwHINModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="authorizeNwHINModalLabel">Authorize</h4>
                    </div>
                    <div class="modal-body" id="authorizeNwHINModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnAuthorizeNwHINModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnAuthorizeNwHINModalSubmit" class="btn btn-primary">Authorize</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="authorizeDelayNwHINModal" role="dialog" data-backdrop="static" aria-labelledby="authorizeDelayNwHINModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="authorizeDelayNwHINModalLabel">Approve Authorization</h4>
                    </div>
                    <div class="modal-body" id="authorizeDelayNwHINModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnAuthorizeDelayNwHINModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnAuthorizeDelayNwHINModalSubmit" class="btn btn-primary">Authorize</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="cancelDelayedAuthorizationModal" role="dialog" data-backdrop="static" aria-labelledby="cancelDelayedAuthorizationModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="cancelDelayedAuthorizationModalLabel">Cancel Authorization</h4>
                    </div>
                    <div class="modal-body" id="cancelDelayedAuthorizationModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnCancelDelayedAuthorizationModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnCancelDelayedAuthorizationModalSubmit" class="btn btn-primary">Cancel Authorization</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="modifyRestrictionsModal" role="dialog" data-backdrop="static" aria-labelledby="modifyRestrictionsModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="modifyRestrictionsModalLabel">View/Modify <c:out value="${organizationName}"/> Organization Restriction</h4>
                    </div>
                    <div class="modal-body" id="modifyRestrictionsModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnModifyRestrictionsModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnModifyRestrictionsModalSubmit" class="btn btn-primary">Restrict</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="revokeRestrictionsModal" role="dialog" data-backdrop="static" aria-labelledby="revokeRestrictionsModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="revokeRestrictionsModalLabel">Revoke or Terminate <c:out value="${organizationName}"/> Organization Restriction</h4>
                    </div>
                    <div class="modal-body" id="revokeRestrictionsModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnRevokeRestrictionsModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnRevokeRestrictionsModalSubmit" class="btn btn-primary">Revoke</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade vap-modal-empty-on-close" id="manageRestrictionsModal" role="dialog" data-backdrop="static" aria-labelledby="manageRestrictionsModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog modal-lg vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="manageRestrictionsModalLabel">Manage Veteran Restrictions</h4>
                    </div>
                    <div class="modal-body" id="manageRestrictionsModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" id="btnManageRestrictionsModalClose" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="btnManageRestrictionsModalSubmit" class="btn btn-primary">Restrict</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>
