<%-- 
    Document   : patientDiscoverySummaryReport
    Created on : Jun 5, 2015, 12:04:48 PM
    Author     : Irakli Kakushadze
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@page import="java.util.*"%>

<f:mainTemplate headerText="Patient Discovery Audit Summary Report">
    <script language="JavaScript">
        $(document).ready(function () {
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${tomorrow}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                min: '<c:out value="${startDateDefault}" />',
                max: '<c:out value="${tomorrow}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });
            
            VAP.common.constructUrl = function(methodName){
                var url= 'PatientDiscoverySummaryReport.do_sec' +
                    '?' + methodName + '=true' +
                    '&startDate=' + $('#startDate').val() +
                    '&startDateHour=' + $('#startDateHour').val() +
                    '&startDateMinute=' + $('#startDateMinute').val() + 
                    '&startDateMeridian=' + $('#startDateMeridian').val() +
                    '&endDate=' + $('#endDate').val() +
                    '&endDateHour=' + $('#endDateHour').val() +
                    '&endDateMinute=' + $('#endDateMinute').val() +
                    '&endDateMeridian=' + $('#endDateMeridian').val() +
                    '&userId=' + $('#userId').val() +
                    //'&organization=' + $('#organization').val() +
                    //'&organizationName=' + $('#orgName').val() +
                    '&sendingOrganization=' + $('#sendingOrganization').val() + 
                    '&sendingOrganizationName=' + $("#sendingOrganization option:selected").text().trim() +
                    '&receivingOrganization=' + $('#receivingOrganization').val() + 
                    '&receivingOrganizationName=' + $("#receivingOrganization option:selected").text().trim() +
                    '&facility=' + $('#facility').val() +
                    '&facilityName=' + $("#facility option:selected").text().trim() +
                    '&patientTypes=' + $('#patientTypes').val() +
                    '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                    '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1];
                return url;
            };
            
             VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
             
            //updates datatables with ajaxed data along with audit count
            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                ajax: { 
                    url: VAP.common.constructUrl("doSearch"),
                    dataSrc: function(json){
                        $('.dataTables_empty').remove();
                        return json.data;
                    },
                    error: function(o){
                        VAP.common.handleErrorsInDataTable('reportTable', o, 9, 'divReportPanel');
                    }
                }, 
                info: false,
                language: {
                    emptyTable: "No records found",
                    loadingRecords: ""
                },
                ordering: true,
                paging: false,
                processing: true,
                searching: false,
                serverSide: true,
                columnDefs: [
                    {className: "width-200", targets: [0,1]},
                    {className: "text-right", targets: [2,3,4,5,6,7,8]}
                ],
                "footerCallback": function ( row, data, start, end, display ) {
                    var api = this.api(), data;

                    // Update footer
                    $(api.column(2).footer() ).html(
                        api.column(2, {page:'current'}).data().sum()
                    );
            
                    $(api.column(3).footer() ).html(
                        api.column(3, {page:'current'}).data().sum()
                    );
            
                    $(api.column(4).footer() ).html(
                        api.column(4, {page:'current'}).data().sum()
                    );
            
                    $(api.column(5).footer() ).html(
                        api.column(5, {page:'current'}).data().sum()
                    );
            
                    $(api.column(6).footer() ).html(
                        api.column(6, {page:'current'}).data().sum()
                    );
            
                    $(api.column(7).footer() ).html(
                        api.column(7, {page:'current'}).data().sum()
                    );
            
                    $(api.column(8).footer() ).html(
                        api.column(8, {page:'current'}).data().sum()
                    );
                }
            });
            
            // DataTable overrides
            $.fn.dataTable.ext.errMode = 'none';
            
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
            });

            $('#searchButton').on('click', function () {
                var fullStartDate = $('#startDate').val() + ' ' + $('#startDateHour').val() + ':' + $('#startDateMinute').val() + ' ' + $('#startDateMeridian').val();
                var fullEndDate = $('#endDate').val() + ' ' + $('#endDateHour').val() + ':' + $('#endDateMinute').val() + ' ' + $('#endDateMeridian').val();
                
                var errorMessage = VAP.common.validateStartAndEndDateWithTime(fullStartDate, fullEndDate, true, '<c:out value="${tomorrow}" />');
                
                var validationRslt = $('#patientDiscoverySummaryReportForm').validator('validate');
                if (validationRslt.has('.has-error').length)
                {
                    errorMessage = 'Both sending and receiving organizations cannot be selected. Please choose only one.';
                }
                
                if (errorMessage != '')
                {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
                }
            });
            
            $('#patientDiscoverySummaryReportForm').validator({
                custom: {
                    areBothOrgsSelected: function($el) { 
                        return ($('#sendingOrganization').val().length && $('#receivingOrganization').val().length); 
                    }
                }
            });
            
            $('#startDate,#endDate,#startDateHour,#startDateMinute,#startDateMeridian,#endDateHour,#endDateMinute,#endDateMeridian,#sendingOrganization,#receivingOrganization').on('change', function () {
                //if either date or time changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            $('#results').hide();
        });
    </script>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Search Criteria" aria-label="Search Criteria" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="patientDiscoverySummaryReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="patientDiscoverySummaryReportSearchPanel">
                    <form name="patientDiscoverySummaryReportForm" id="patientDiscoverySummaryReportForm" class="form-horizontal" data-toggle="validator" role="form">
                        <div id="errorMessage" class="alert alert-warning pad-15 margin-bottom-10" style="display: none;" role="alert"></div>
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateDefault}" />" /> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" name="startDate" id="startDate" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />" value="<c:out value="${startDateDefault}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label id="startTimeLabel" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Time</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3 form-inline" data-tooltip="<c:out value="${descriptors['startDateEndDateTimeField']}" />"> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3 form-inline">
                                <span class="js-simple-tooltip" data-simpletooltip-prefix-class="secondary"  data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateTimeField']}" />">
                                    <date:timePicker prefixId="startDate" prefixName="startDate" hourSelected="12" labelPrefix="Start Time" />
                                </span>
                            </div>
                        </div>     
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${tomorrow}" />" /> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" name="endDate" id="endDate" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />" value="<c:out value="${tomorrow}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label id="endTimeLabel" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Time</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3 form-inline" data-tooltip="<c:out value="${descriptors['startDateEndDateTimeField']}" />"> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3 form-inline">
                                <span class="js-simple-tooltip" data-simpletooltip-prefix-class="secondary"  data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateTimeField']}" />">
                                    <date:timePicker prefixId="endDate" prefixName="endDate" hourSelected="12" labelPrefix="End Time" />
                                </span>
                            </div>
                        </div>       
                        <div class="form-group">
                            <label for="userId" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">User ID</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <input title="Enter User ID" id="userId" name="userId" type="text" maxlength="255" size="30" class="form-control" data-tooltip="<c:out value="${descriptors['genericUserId']}" />" /> --%>
                                <input title="Enter User ID" id="userId" name="userId" type="text" maxlength="255" size="30" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['genericUserId']}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="facility" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">
                                Patient Preferred Facility
                            </label> 
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select data-tooltip="<c:out value="${descriptors['patientPreferredFacilityFilter']}"/>" id="facility" name="facility" class="form-control"> --%>
                                <select data-simpletooltip-text="<c:out value="${descriptors['patientPreferredFacilityFilter']}"/>" id="facility" name="facility" class="form-control js-simple-tooltip">
                                    <option value="">ALL</option>
                                    <c:forEach var="f" items="${facilities}">
                                        <option value="<c:out value="${f.facilityStation}"/>"
                                                <c:choose>
                                                    <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                                        selected
                                                    </c:when>
                                                </c:choose>>
                                            <c:choose>
                                                <c:when test="${f.facilityName != ''}">
                                                    <c:out value="${f.facilityName}"/>
                                                </c:when>
                                                <c:otherwise>
                                                    <c:out value="${fn:split(f.facilityDns, '.')[0]}" />
                                                </c:otherwise>
                                            </c:choose>
                                            (<c:out value="${f.facilityStation}"/>)
                                        </option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="sendingOrganization" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">
                                Sending Organization
                            </label> 
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select data-tooltip="<c:out value="${descriptors['disclosuresReportSendingOrganizationField']}"/>" id="sendingOrganization" name="sendingOrganization" class="form-control" data-areBothOrgsSelected="areBothOrgsSelected"> --%>
                                <select data-simpletooltip-text="<c:out value="${descriptors['disclosuresReportSendingOrganizationField']}"/>" id="sendingOrganization" name="sendingOrganization" class="form-control js-simple-tooltip" data-areBothOrgsSelected="areBothOrgsSelected">
                                    <option value="" selected>ALL</option>
                                    <c:forEach var="r" items="${activeOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">
                                            <c:out value="${r.orgName}"/>
                                        </option>
                                    </c:forEach>
                                    <c:forEach var="r" items="${inactiveOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">[INACTIVE] <c:out value="${r.orgName}"/></option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="receivingOrganization" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">
                                Receiving Organization
                            </label> 
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select data-tooltip="<c:out value="${descriptors['disclosuresReportReceivingOrganizationField']}"/>" id="receivingOrganization" name="receivingOrganization" class="form-control" data-areBothOrgsSelected="areBothOrgsSelected"> --%>
                                <select data-simpletooltip-text="<c:out value="${descriptors['disclosuresReportReceivingOrganizationField']}"/>" id="receivingOrganization" name="receivingOrganization" class="form-control js-simple-tooltip" data-areBothOrgsSelected="areBothOrgsSelected">
                                    <option value="" selected>ALL</option>
                                    <c:forEach var="r" items="${activeOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">
                                            <c:out value="${r.orgName}"/>
                                        </option>
                                    </c:forEach>
                                    <c:forEach var="r" items="${inactiveOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">[INACTIVE] <c:out value="${r.orgName}"/></option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>
<%--                        <div class="form-group">
                            <label for="organization" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">
                                Organization
                            </label> 
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <select data-tooltip="<c:out value="${descriptors['disclosuresSummaryReportOrganizationField']}"/>" id="organization" name="organization" class="form-control" onchange="document.getElementById('orgName').value = this.options[this.selectedIndex].text;">
                                    <option value="" selected>ALL</option>
                                    <c:forEach var="r" items="${activeOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">
                                            <c:out value="${r.orgName}"/>
                                        </option>
                                    </c:forEach>
                                    <c:forEach var="r" items="${inactiveOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">[INACTIVE] <c:out value="${r.orgName}"/></option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>--%>
                        <div class="form-group">
                            <label for="patientTypes" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Types<span style="display:none;">"Choose whether you would like to filter by real patients only, test patients only, or both."</span></label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select data-tooltip="<c:out value="${descriptors['patientTypesField']}"/>" id="patientTypes" name="patientTypes" class="form-control"> --%>
                                <select data-simpletooltip-text="<c:out value="${descriptors['patientTypesField']}"/>" id="patientTypes" name="patientTypes" class="form-control js-simple-tooltip">
                                    <option value="3">ALL</option>
                                    <option value="1" selected>Real Patients</option>
                                    <option value="2">Test Patients</option>
                                </select>
                            </div>
                        </div>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5 text-right">
                            <input name="search" title="Search" class="btn btn-primary" type="submit" value="Search" id="searchButton"/>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="row">
            <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                <div class="panel panel-default" id="divReportPanel">
                    <div class="panel-heading">
                        <div class="panel-title">
                            <div class="pull-left">
                                <a href="#" title="Search Results" aria-label="Search Results" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="patientDiscoverySummaryReportResultsPanel"></i></a> Search Results
                            </div>
                            <div class="pull-right">
                                <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                            </div>
                            <div class="clearfix"></div>
                        </div>
                    </div>    
                    <div class="panel-body" id="patientDiscoverySummaryReportResultsPanel">
                        <table id="reportTable" class="table table-striped" width=100% cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <%-- <th role="columnheader" class="text-center"><span id="orgHeader" data-tooltip="<c:out value="${descriptors['eHealthExchangeOrganizationColumn']}" />"><c:out value="${organizationName}" /> Organization</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="facilityHeader" data-tooltip="<c:out value="${descriptors['vaFacilityColumn']}" />">Patient Preferred Facility</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="auditsHeader" data-tooltip="<c:out value="${descriptors['auditsColumn']}" />">Audits</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="uniqueRealPatientsHeader" data-tooltip="<c:out value="${descriptors['uniqueRealPatientsCountColumn']}" />">Unique Real Patients</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="matchesFoundRealPatientsHeader" data-tooltip="<c:out value="${descriptors['matchesFoundForRealPatientsCountColumn']}" />">Matches Found for Real Patients</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="matchFailsRealPatientsHeader" data-tooltip="<c:out value="${descriptors['failsForRealPatientsCountColumn']}" />">Match Fails for Real Patients</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="uniqueTestPatientsHeader" data-tooltip="<c:out value="${descriptors['uniqueTestPatientsCountColumn']}" />">Unique Test Patients</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="matchesFoundTestPatientsHeader" data-tooltip="<c:out value="${descriptors['matchesFoundForTestPatientsCountColumn']}" />">Matches Found for Test Patients</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="matchFailsTestPatientsHeader" data-tooltip="<c:out value="${descriptors['failsForTestPatientsCountColumn']}" />" data-tooltip-position="left">Match Fails for Test Patients</span></th> --%>
                                    
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['eHealthExchangeOrganizationColumn']}" />"><span id="orgHeader" data-simpletooltip-target="tableheader"><c:out value="${organizationName}" /> Organization</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['vaFacilityColumn']}" />"><span id="facilityHeader" data-simpletooltip-target="tableheader">Patient Preferred Facility</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['auditsColumn']}" />"><span id="auditsHeader" data-simpletooltip-target="tableheader">Audits</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['uniqueRealPatientsCountColumn']}" />"><span id="uniqueRealPatientsHeader" data-simpletooltip-target="tableheader">Unique Real Patients</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['matchesFoundForRealPatientsCountColumn']}" />"><span id="matchesFoundRealPatientsHeader" data-simpletooltip-target="tableheader">Matches Found for Real Patients</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['failsForRealPatientsCountColumn']}" />"><span id="matchFailsRealPatientsHeader" data-simpletooltip-target="tableheader">Match Fails for Real Patients</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['uniqueTestPatientsCountColumn']}" />"><span id="uniqueTestPatientsHeader" data-simpletooltip-target="tableheader">Unique Test Patients</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['matchesFoundForTestPatientsCountColumn']}" />"><span id="matchesFoundTestPatientsHeader" data-simpletooltip-target="tableheader">Matches Found for Test Patients</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['failsForTestPatientsCountColumn']}" />"><span id="matchFailsTestPatientsHeader" data-simpletooltip-target="tableheader">Match Fails for Test Patients</span></th>
                                </tr>
                            </thead>
                            <tfoot>
                                <tr role="row">
                                    <%--Filled in by datatables, total--%>
                                    <td role="gridcell" class="text-left bold">Total:</td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                </tr>
                            </tfoot>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>