<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<f:mainTemplate headerText="Set Default Facility">
    <script type="text/javascript">
        function newState(currentState) {
            if (currentState == "manual") {
                //hide auto and none
                $('#content-page-auto').hide();
                $('#content-page-none').hide();
                $('#content-page-label-auto').hide();
                $('#content-page-label-none').hide();
                $('#removeManualFacility').prop('disabled', false);
                //show manual state
                $('#content-page-manual').show();
                $('#content-page-label-manual').show();
            } else if (currentState == "auto") {
                //hide manual and none
                $('#content-page-manual').hide();
                $('#content-page-none').hide();
                $('#content-page-label-manual').hide();
                $('#content-page-label-none').hide();
                $('#removeManualFacility').prop('disabled', true);
                //show auto state
                $('#content-page-auto').show();
                $('#content-page-label-auto').show();
            } else {
                //hide manual and auto
                $('#content-page-manual').hide();
                $('#content-page-auto').hide();
                $('#content-page-label-manual').hide();
                $('#content-page-label-auto').hide();
                $('#removeManualFacility').prop('disabled', true);
                //show none state
                $('#content-page-none').show();
                $('#content-page-label-none').show();
            }
        }
        $(document).ready(function () {
            var state = '${facilityState}';
            newState(state);
        });
    </script>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <c:if test="${not empty setDefaultFacilityMessage}"> <%-- used for any messaging back from the server. i.e. error logging in or logged out --%> 
                <div class="alert alert-success alert-dismissible pad-bottom-10 pad-top-10 pad-left-10" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <c:out value="${setDefaultFacilityMessage}" />
                </div>
            </c:if>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="alert alert-info">
                <div id="content-page-manual" style="display: none;"><strong>Your default facility is manually set to <c:out value="${visualDefaultUserFacility}"/></strong></div>
                <div id="content-page-auto" style="display: none;"><strong>Your default facility is automatically set to <c:out value="${visualDefaultUserFacility}"/>, based on your user ID.</strong></div>
                <div id="content-page-none" style="display: none;">You do not currently have a default facility. To set a default Facility, choose a facility from the drop down list and click Set Default Facility.</div>
                <div id="content-page-label-manual" style="display: none;">To change your default setting, choose a facility from the drop down list and click Set Default Facility. To remove your default setting and revert to the automatic system setting, click Remove Default Facility</div>
                <div id="content-page-label-auto" style="display: none;">To change your default setting, choose a facility from the drop down list and click Set Default Facility. *Note: the option to remove the automatic system is not available.</div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <form class="form-horizontal" name="setDefaultFacilityForm" action="SetDefaultFacility.do_sec" method="POST">
                <div class="form-group">
                    <label for="facility" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label"><f:requiredField altText="VA Facility is a required field." labelText="VA Facility" /></label>
                    <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                        <%-- <select id="facility" name="facility" data-tooltip="<c:out value="${descriptors['defaultFacilityField']}"/>" class="form-control"> --%>
                        <select id="facility" name="facility" data-simpletooltip-text="<c:out value="${descriptors['defaultFacilityField']}"/>" class="form-control js-simple-tooltip" required>
                            <c:forEach var="f" items="${facilities}">
                                <option value="<c:out value="${f.facilityStation}"/>"
                                    <c:choose>
                                        <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                            selected
                                        </c:when>
                                        <c:when test="${cookie.facility.value == f.facilityStation}">
                                            selected
                                        </c:when>
                                    </c:choose>>
                                    <c:choose>
                                        <c:when test="${f.facilityName != ''}">
                                            <c:out value="${f.facilityName}"/>
                                        </c:when>
                                        <c:otherwise>
                                            <c:out value="${fn:split(f.facilityDns, '.')[0]}"/>
                                        </c:otherwise>
                                    </c:choose>
                                    (<c:out value="${f.facilityStation}"/>)
                                </option>
                            </c:forEach>
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-xs-7 col-sm-7 col-md-7 col-lg-6 text-right">
                        <%-- <input id="removeManualFacility" name="removeManualFacility" title="Remove Default Facility" class="btn btn-default" type="submit" value="Remove Default Facility" style="z-index: -1;" data-tooltip="<c:out value="${descriptors['removeDefaultFacilityButton']}"/>" /> --%>
                        <input id="removeManualFacility" name="removeManualFacility" title="Remove Default Facility" class="btn btn-default js-simple-tooltip" type="submit" value="Remove Default Facility" style="z-index: -1;" data-simpletooltip-text="<c:out value="${descriptors['removeDefaultFacilityButton']}"/>" />
                        <%-- <input id="setManualFacility" name="setManualFacility" data-tooltip="<c:out value="${descriptors['setDefaultFacilityButton']}" />" class="btn btn-primary" type="submit" value="Set Default Facility" /> --%>
                        <input id="setManualFacility" name="setManualFacility" data-simpletooltip-text="<c:out value="${descriptors['setDefaultFacilityButton']}" />" class="btn btn-primary js-simple-tooltip" type="submit" value="Set Default Facility" />
                    </div>
                </div>
            </form>
        </div>
    </div>
</f:mainTemplate>