<%-- 
    Document   : statusChecker
    Created on : Feb 2, 2018, 7:30:22 AM
    Author     : Johann P. Sonnenberg
--%>

<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<f:mainTemplate headerText="VAP Connected Systems Status Check">
    <script type="text/javascript">
        $(document).ready(function () {
            //make the ajax calls to check the services
            checkExchange();
            checkMVI();
            checkDirect();
            checkVistA();
            checkESR();
            checkBulkDownload();
            
            //copy to clipboard functionality 
            $('#copiedAlert').hide();

            $('#copyButton').on('click', function () {
                clipboard.copy($('#statusCheckerViewMoreDetailsModalBody').html());
                $('#copiedAlert').show();
                $('#copiedAlert').delay(500).fadeIn('normal', function () {
                    $(this).delay(2500).fadeOut();

                });
            });
            
            //on show of the error detail modal, pull in the error from the hidden divs (at the bottom of this page)
            $('#statusCheckerViewMoreDetailsModal').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var system = button.data('service');
                var errorData = $('#div' + system + 'ErrorDetails').html();
                
                $('#statusCheckerViewMoreDetailsModalBody').html(errorData);
            });
            
            //onclick handler for the Retry buttons for each service
            $('.retryCheck').on('click', function(){
                var service = $(this).data("service");
                
                window['check' + service]();
            });
        });
        
        var checkExchange = function() {
            //hide the success and error divs
            $('#divExchangeSuccess').hide();
            $('#divExchangeError').hide();
            
            //show the "loading" spinner
            $('#divExchangeSpinner').show();

            //make the call to check on Exchange
            $.ajax({url: "StatusChecker.do_sec?checkExchangeStatus=true", 
                success: function (result) {
                    var info = $.parseJSON(result);

                    if(info.pass) {
                        //yah! we connected properly
                        $('#divExchangeError').hide();
                        $('#divExchangeSuccessDateTime').html(info.dateTimeChecked);
                        $('#divExchangeSuccess').show();
                    } else {
                        //ah snap! we got a connection error
                        $('#divExchangeSuccess').hide();            
                        $('#divExchangeErrorDateTime').html(info.dateTimeChecked);
                        $('#divExchangeError').show();

                        //populate the Exchange modal more details body with the error text
                        $('#divExchangeErrorDetails').html(info.error);
                    }

                    //hide the "loading" spinner
                    $('#divExchangeSpinner').hide();
                }
            });
        };

        var checkMVI = function () {
            //hide the success and error divs
            $('#divMVISuccess').hide();
            $('#divMVIError').hide();
            
            //show the "loading" spinner
            $('#divMVISpinner').show();

            //make the call to check on MVI
            $.ajax({url: "StatusChecker.do_sec?checkMVIStatus=true", 
                success: function (result) {
                    var info = $.parseJSON(result);

                    if(info.pass) {
                        //yah! we connected properly
                        $('#divMVIError').hide();
                        $('#divMVISuccessDateTime').html(info.dateTimeChecked);
                        $('#divMVISuccess').show();
                    } else {
                        //ah snap! we got a connection error
                        $('#divMVISuccess').hide();            
                        $('#divMVIErrorDateTime').html(info.dateTimeChecked);
                        $('#divMVIError').show();

                        //populate the MVI modal more details body with the error text
                        $('#divMVIErrorDetails').html(info.error);
                    }

                    //hide the "loading" spinner
                    $('#divMVISpinner').hide();
                }
            });
        };

        var checkDirect = function() {
            //hide the success and error divs
            $('#divDirectSuccess').hide();
            $('#divDirectError').hide();
            
            //show the "loading" spinner
            $('#divDirectSpinner').show();

            //make the call to check on Direct
            $.ajax({url: "StatusChecker.do_sec?checkDirectStatus=true", 
                success: function (result) {
                    var info = $.parseJSON(result);

                    if(info.pass) {
                        //yah! we connected properly
                        $('#divDirectError').hide();
                        $('#divDirectSuccessDateTime').html(info.dateTimeChecked);
                        $('#divDirectSuccess').show();
                    } else {
                        //ah snap! we got a connection error
                        $('#divDirectSuccess').hide();            
                        $('#divDirectErrorDateTime').html(info.dateTimeChecked);
                        $('#divDirectError').show();

                        //populate the Direct modal more details body with the error text
                        $('#divDirectErrorDetails').html(info.error);
                    }

                    //hide the "loading" spinner
                    $('#divDirectSpinner').hide();
                }
            });
        };

        var checkVistA = function() {
            //hide the success and error divs
            $('#divVistASuccess').hide();
            $('#divVistAError').hide();
            
            //show the "loading" spinner
            $('#divVistASpinner').show();

            //make the call to check on VistA
            $.ajax({url: "StatusChecker.do_sec?checkVistAStatus=true", 
                success: function (result) {
                    var info = $.parseJSON(result);

                    if(info.pass) {
                        //yah! we connected properly
                        $('#divVistAError').hide();
                        $('#divVistASuccessDateTime').html(info.dateTimeChecked);
                        $('#divVistASuccess').show();
                    } else {
                        //ah snap! we got a connection error
                        $('#divVistASuccess').hide();            
                        $('#divVistAErrorDateTime').html(info.dateTimeChecked);
                        $('#divVistAError').show();

                        //populate the VistA modal more details body with the error text
                        $('#divVistAErrorDetails').html(info.error);
                    }

                    //hide the "loading" spinner
                    $('#divVistASpinner').hide();
                }
            });
        };
        
        var checkESR = function() {
            //hide the success and error divs
            $('#divESRSuccess').hide();
            $('#divESRError').hide();
            
            //show the "loading" spinner
            $('#divESRSpinner').show();

            //make the call to check on ESR
            $.ajax({url: "StatusChecker.do_sec?checkESRStatus=true", 
                success: function (result) {
                    var info = $.parseJSON(result);

                    if(info.pass) {
                        //yah! we connected properly
                        $('#divESRError').hide();
                        $('#divESRSuccessDateTime').html(info.dateTimeChecked);
                        $('#divESRSuccess').show();
                    } else {
                        //ah snap! we got a connection error
                        $('#divESRSuccess').hide();            
                        $('#divESRErrorDateTime').html(info.dateTimeChecked);
                        $('#divESRError').show();

                        //populate the ESR modal more details body with the error text
                        $('#divESRErrorDetails').html(info.error);
                    }

                    //hide the "loading" spinner
                    $('#divESRSpinner').hide();
                }
            });
        };
        
        var checkBulkDownload = function() {
            //hide the success and error divs
            $('#divBulkDownloadSuccess').hide();
            $('#divBulkDownloadError').hide();
            
            //show the "loading" spinner
            $('#divBulkDownloadSpinner').show();

            //make the call to check on BulkDownload
            $.ajax({url: "StatusChecker.do_sec?checkBulkDownloadStatus=true", 
                success: function (result) {
                    var info = $.parseJSON(result);

                    if(info.pass) {
                        //yah! we connected properly
                        $('#divBulkDownloadError').hide();
                        $('#divBulkDownloadSuccessDateTime').html(info.dateTimeChecked);
                        $('#divBulkDownloadSuccess').show();
                    } else {
                        //ah snap! we got a connection error
                        $('#divBulkDownloadSuccess').hide();            
                        $('#divBulkDownloadErrorDateTime').html(info.dateTimeChecked);
                        $('#divBulkDownloadError').show();

                        //populate the BulkDownload modal more details body with the error text
                        $('#divBulkDownloadErrorDetails').html(info.error);
                    }

                    //hide the "loading" spinner
                    $('#divBulkDownloadSpinner').hide();
                }
            });
        };
    </script>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12"> 
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Status Checks" aria-label="Status Checks" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="statusSearchPanel"></i></a> Status
                    </div> 
                </div>   
                <div class="panel-body" id="statusSearchPanel"> 
                    <%-- Exchange --%>
                    <div class="row">
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                            <h2>Exchange</h2>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                            <div id="divExchangeError" class="alert alert-danger" style="display: none;" role="alert">
                                <strong>Error!</strong> There was an error connecting to the Exchange service at <span id="divExchangeErrorDateTime"></span>. <a href="#" class="pull-right" data-service="Exchange" data-toggle="modal" data-target="#statusCheckerViewMoreDetailsModal">View Error Details</a>
                            </div>
                            <div id="divExchangeSuccess" class="alert alert-success" style="display: none;" role="alert">
                                <strong>Success!</strong> The connection to the Exchange service succeeded at <span id="divExchangeSuccessDateTime"></span>.
                            </div>
                            <div id="divExchangeSpinner" class="img-center" style="display: none;">
                                <img src="resources/images/ajax-loader_1.gif" alt="Loading..."/>
                            </div>
                        </div>
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 pad-top-5">
                            <button class="btn retryCheck" id="refreshButton" title="Retry" data-service="Exchange">Retry <span class="fa fa-refresh" aria-hidden="true"></span></button>
                        </div>
                    </div>
                    <%-- MVI --%>
                    <div class="row">
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                            <h2>MVI</h2>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                            <div id="divMVIError" class="alert alert-danger" style="display: none;" role="alert">
                                <strong>Error!</strong> There was an error connecting to the MVI service at <span id="divMVIErrorDateTime"></span>. <a href="#" class="pull-right" data-service="MVI" data-toggle="modal" data-target="#statusCheckerViewMoreDetailsModal">View Error Details</a>
                            </div>
                            <div id="divMVISuccess" class="alert alert-success" style="display: none;" role="alert">
                                <strong>Success!</strong> The connection to the MVI service succeeded at <span id="divMVISuccessDateTime"></span>.
                            </div>
                            <div id="divMVISpinner" class="img-center" style="display: none;">
                                <img src="resources/images/ajax-loader_1.gif" alt="Loading..."/>
                            </div>
                        </div>
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 pad-top-5">
                            <button class="btn retryCheck" id="refreshButton" title="Retry" data-service="MVI">Retry <span class="fa fa-refresh" aria-hidden="true"></span></button>
                        </div>
                    </div>
                    <%-- Direct --%>
                    <div class="row">
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                            <h2>Direct</h2>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                            <div id="divDirectError" class="alert alert-danger" style="display: none;" role="alert">
                                <strong>Error!</strong> There was an error connecting to the Direct service at <span id="divDirectErrorDateTime"></span>. <a href="#" class="pull-right" data-service="Direct" data-toggle="modal" data-target="#statusCheckerViewMoreDetailsModal">View Error Details</a>
                            </div>
                            <div id="divDirectSuccess" class="alert alert-success" style="display: none;" role="alert">
                                <strong>Success!</strong> The connection to the Direct service succeeded at <span id="divDirectSuccessDateTime"></span>.
                            </div>
                            <div id="divDirectSpinner" class="img-center" style="display: none;">
                                <img src="resources/images/ajax-loader_1.gif" alt="Loading..."/>
                            </div>
                        </div>
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 pad-top-5">
                            <button class="btn retryCheck" id="refreshButton" title="Retry" data-service="Direct">Retry <span class="fa fa-refresh" aria-hidden="true"></span></button>
                        </div>
                    </div>
                    <%-- VistA --%>
                    <div class="row">
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                            <h2>VistA</h2>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                            <div id="divVistAError" class="alert alert-danger" style="display: none;" role="alert">
                                <strong>Error!</strong> There was an error connecting to the VistA service at <span id="divVistAErrorDateTime"></span>. <a href="#" class="pull-right" data-service="VistA" data-toggle="modal" data-target="#statusCheckerViewMoreDetailsModal">View Error Details</a>
                            </div>
                            <div id="divVistASuccess" class="alert alert-success" style="display: none;" role="alert">
                                <strong>Success!</strong> The connection to the VistA service succeeded at <span id="divVistASuccessDateTime"></span>.
                            </div>
                            <div id="divVistASpinner" class="img-center" style="display: none;">
                                <img src="resources/images/ajax-loader_1.gif" alt="Loading..."/>
                            </div>
                        </div>
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 pad-top-5">
                            <button class="btn retryCheck" id="refreshButton" title="Retry" data-service="VistA">Retry <span class="fa fa-refresh" aria-hidden="true"></span></button>
                        </div>
                    </div>
                    <%-- ESR --%>
                    <div class="row">
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                            <h2>ESR</h2>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                            <div id="divESRError" class="alert alert-danger" style="display: none;" role="alert">
                                <strong>Error!</strong> There was an error connecting to the ESR service at <span id="divESRErrorDateTime"></span>. <a href="#" class="pull-right" data-service="ESR" data-toggle="modal" data-target="#statusCheckerViewMoreDetailsModal">View Error Details</a>
                            </div>
                            <div id="divESRSuccess" class="alert alert-success" style="display: none;" role="alert">
                                <strong>Success!</strong> The connection to the ESR service succeeded at <span id="divESRSuccessDateTime"></span>.
                            </div>
                            <div id="divESRSpinner" class="img-center" style="display: none;">
                                <img src="resources/images/ajax-loader_1.gif" alt="Loading..."/>
                            </div>
                        </div>
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 pad-top-5">
                            <button class="btn retryCheck" id="refreshButton" title="Retry" data-service="ESR">Retry <span class="fa fa-refresh" aria-hidden="true"></span></button>
                        </div>
                    </div>
                    <%-- BulkDownload --%>
                    <div class="row">
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                            <h2>Bulk Download</h2>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                            <div id="divBulkDownloadError" class="alert alert-danger" style="display: none;" role="alert">
                                <strong>Error!</strong> There was an error connecting to the Bulk Download service at <span id="divBulkDownloadErrorDateTime"></span>. <a href="#" class="pull-right" data-service="BulkDownload" data-toggle="modal" data-target="#statusCheckerViewMoreDetailsModal">View Error Details</a>
                            </div>
                            <div id="divBulkDownloadSuccess" class="alert alert-success" style="display: none;" role="alert">
                                <strong>Success!</strong> The connection to the Bulk Download service succeeded at <span id="divBulkDownloadSuccessDateTime"></span>.
                            </div>
                            <div id="divBulkDownloadSpinner" class="img-center" style="display: none;">
                                <img src="resources/images/ajax-loader_1.gif" alt="Loading..."/>
                            </div>
                        </div>
                        <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 pad-top-5">
                            <button class="btn retryCheck" id="refreshButton" title="Retry" data-service="BulkDownload">Retry <span class="fa fa-refresh" aria-hidden="true"></span></button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
                    
    <%-- modal for errors returned detail view --%>
    <div class="modal fade" id="statusCheckerViewMoreDetailsModal" role="dialog" data-backdrop="static" aria-labelledby="statusCheckerViewMoreDetailsModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center modal-lg" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="statusCheckerViewMoreDetailsModalLabel">Error Detail</h4>
                    </div>
                    <div class="modal-body" aria-live="assertive" role="alert">
                        <div class="pre-scrollable" id="statusCheckerViewMoreDetailsModalBody"></div>
                        <div class="text-right margin-top-10">
                            <span id="copiedAlert" class="bg-success pad-10">Copied!</span>
                            <button id="copyButton" class="btn btn-primary">Copy to Clipboard</button>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    
    <%-- hidden divs that are used to house the error details from the status checks for the services --%>
    <div id="divExchangeErrorDetails" class="hidden"></div>
    <div id="divMVIErrorDetails" class="hidden"></div>
    <div id="divDirectErrorDetails" class="hidden"></div>
    <div id="divVistAErrorDetails" class="hidden"></div>
    <div id="divESRErrorDetails" class="hidden"></div>
    <div id="divBulkDownloadErrorDetails" class="hidden"></div>
</f:mainTemplate>